#include "edge.h"
#include "vcrypt.h"
//------------------------------------------------
void
edgeCorrection (unsigned char *buffer, int xWidth, int skip,
                int yBorderHeight)
{
  int i, j, k, s, best_edge_shift = 0, edge_position;
  int rsc[768];                    // relative_shift_count
  int ms[768];                    // mittelung der shift
  int cp[288];                    // kontrast position innerhalb der zeile
  int gd_breite;

  for (i = 0; i < 768; i++)
    rsc[i] = 0;
  for (i = yBorderHeight; i < (288 - yBorderHeight); i++)
    rsc[h_offset[i]]++;            // zaehle wie oft bestimmte offsets auftreten

  //---------------------------------------------
  gd_breite = (int) (double) xWidth *100.0 / 768.0;    // bei 768->100, bei 384->50;

  for (i = 0; i < (xWidth - skip); i++)    //  gleitender durchschnitt ueber rsc 
    {
      s = 0;
      for (j = -gd_breite; j <= gd_breite; j++)
        {
          k = i + j;
          if (k < 0)
            k = xWidth - skip + k;    // das geht auch eleganter
          if (k >= (xWidth - skip))
            k = k - (xWidth - skip);
          s = s + rsc[k];
        }
      ms[i] = s;
    }
  //--------------------------------------------- 
  j = 35535;
  for (i = 0; i < (xWidth - skip); i++)
    if (ms[i] < j)
      {
        best_edge_shift = i;
        j = ms[i];
      }

  edge_position = xWidth - skip - best_edge_shift;    // das ist etwa der rand
  edge_position &= ~1;

  for (i = 0; i < 288; i++)
    cp[i] = edge_position;
//---------------------------------------------------

  // feinjustierung ....
//---------------------------------------------------

  for (i = yBorderHeight; i < (288 - yBorderHeight); i++)
    {
      rotateFirstHalfLine (&buffer[2 * i * 2 * xWidth], cp[i], xWidth, skip);
      h_offset[i] = (h_offset[i] + (cp[i])) % (xWidth - skip);
    }

}

//------------------------------------------------
