////////////////////////////////////////////////////////////////
// MeuhMeuhTV 09/03/2001
////////////////////////////////////////////////////////////////
// Code original FASOUIL 
// Adaptation Xawdecode par Keuleu 15/04/2001
////////////////////////////////////////////////////////////////
// CFiltre
////////////////////////////////////////////////////////////////
#ifndef _FASOUIL_H_
#define _FASOUIL_H_

#ifdef ENABLE_FASOUIL

#ifndef FALSE
# define FALSE 0
#endif
#ifndef TRUE
# define TRUE (!FALSE)
#endif

#define EVEN 0 // pair
#define ODD  1 // impair

#define SEUIL_SATURATION_COULEUR 0xa0
#define TAILLE_DECODE_TRAME_CX 384
#define TAILLE_DECODE_TRAME_CY 287

#define SUPERPOSE_MOVING 0    // plan qui bouge
#define SUPERPOSE_STATIC  1    // plan fixe

struct fasouil_param_t
{
  int bFiltreMoyenneur;
  int bFiltreViolet;
  int bFiltreAntiBavure;
  int EssaiSuperposition;
  int bPhaseFiltreUnKonnus;
  int bPhaseFiltreAntiBavure;
  int iUVThresholdPCent;
  int CoefFiltreVert;
};

typedef struct fasouil_param_t FASOUIL_PARAM;

enum {
  FASOUIL_SMUDGE = 1,
  FASOUIL_AVERAGE,
  FASOUIL_SUPERPOSE,
  FASOUIL_UNKONNU_PHASE,
  FASOUIL_SMUDGE_PHASE,
  FASOUIL_UV_THRESHOLD,
  FASOUIL_GREEN_COEFF
};

void init_fasouil_filter (void);

//-------------------------
//public

void EnleveLaPremiereLigne ( /*CUneTrame * p_Frame */ long **pLinesAddress,
                unsigned short *pSortLines);
void FiltreImage ( /*CUneTrame * p_Frame */ unsigned char *src,
          long **pLinesAddress, unsigned short *pSortLines,
          int parity, int save_src);
void MoyenneAvecPrecedanteUnPeu ( /*CUneTrame * p_Frame */ long
                 **pLinesAddress, unsigned short *pSortLines);
void SupprimeLigneViolet ( /*CUneTrame * p_Frame */ long **pLinesAddress,
              unsigned short *pSortLines);
void ReconstituUSB ( /*CUneTrame * p_Frame */ long **pLinesAddress,
            unsigned short *pSortLines);
void FiltreUnKonnu ( /*CUneTrame * p_Frame */ long **pLinesAddress,
            unsigned short *pSortLines);
#ifdef OLD_VerifiPhaseFiltreUnKonnu
void VerifiPhaseFiltreUnKonnu ( /*CUneTrame * p_Frame */ long **pLinesAddress,
                                unsigned short *pSortLines, int bPhaseFiltre);
#endif
#ifdef NEW_VerifiPhaseFiltreUnKonnu
void VerifiPhaseFiltreUnKonnu ( /*CUneTrame * p_Frame */ long **pLinesAddress);
#endif
int Correlation (short *donnee1, short *donnee2, int taille_donnee);
void DiminueVertATI ( /*CUneTrame * p_Frame */ long **pLinesAddress,
             unsigned short *pSortLines);


// Private
struct SIZE_T
{
  int cx;
  int cy;
};

typedef struct SIZE_T SIZE;

#endif // ENABLE_FASOUIL

#endif // _FASOUIL_H_
