#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <assert.h>
#include "config.h"
#include "videodev.h"
#include "bttv.h"
#include "grab.h"
#include "crypt.h"
#include "nagra.h"
#include "keys.h"
#include "const.h"
#include "putline.h"
#include "prep-tabs.h"
#include "prep-tabs2.h"
#include "filtre.h"
#include "kizkool.h"
#include "fasouil.h"
#include "memcpy.h"

#include "../mm/pluginvideo.h"

extern int even;
extern struct video_mbuf gb_buffers;

QuenotteTV_VideoPlugin *meuhmeuh=NULL;
QuenotteTV_VideoPlugin *init_mm_Plugin(char *);

extern int grabber;
extern int cur_norm;
extern char user_dir[255];
extern int have_xv;
extern int bpp;
extern int bluefilter;
#ifndef DISABLE_ALL_KIZKOOL
 extern int TypeImage;
 extern int CurrentX;
 extern int MovieScale;
 extern KIZKOOL_PARAM kizkool_param[NB_KIZKOOL_FILTER];
#endif
#ifdef ENABLE_FASOUIL
 extern SIZE TailleDecodeTrame;
 extern int HauteurBandeNoire;
#endif
extern int decode;

extern int nagra_coded;
int burst_phase;
int burst_phase_e;
int burst_phase_orig;
int status_line = 0;             // line number of the WideScreenLine
int highquality = 0;             // 
int use_wss_line = 0;            // PAL PLUS
int force_not_use_wss_line = 0;  //
int number_couples = NB_COUPLES; // nb of lines to run correlation against
extern int direct_video;
extern int direct_xsize;
int ybar = 1; // still need to understand why ybar can't be zero without segfaulting!
int ybar_auto = FALSE;
//#define TOLERANCE 5  // 20 %
//#define TOLERANCE 7  // 14.3 %
//#define TOLERANCE 10 // 10%
//#define TOLERANCE 20 //  5%
int blackborder_tolerance = 5;

static volatile unsigned long nMaskY[2] =          { 0x00ff00ff, 0x00ff00ff };
static volatile unsigned long CurrentLowValue[2] = { 0x002d002d, 0x002d002d };
static int bbfrcount = 0;

unsigned short key_lines[NB_KEYS * NB_COUPLES_MAX];
// enthlt Index auf Zeilenpaare in 'couple_index'
// bzw. auf die zugeordneten
// Korrelationswerte in 'correl_lines',
// fr jeden Schlssel werden
// 'NB_COUPLES' Werte
// hintereinanderliegend gespeichert 

int couple_index_nb;
// Anzahl der Zeilenpaare in 'couple_index'

unsigned int couple_index[NB_COUPLES_MAX * 200];
// enthlt je Element zwei Zeilen (COUPLE)  

unsigned int correl_lines[NB_COUPLES_MAX * 200];
// hier werden die Korrelationen zu den Paaren
// in 'couple_index' gespeichert

//unsigned char framebuf[288*2 * 768*2];
unsigned char linebuf[32 * 924 * 2];
// Buffer fr 32 Zeilen
unsigned char linebuf_e[32 * 924 * 2];
unsigned char linebuf_o[32 * 924 * 2];

unsigned int BlackSet[288];

short colortable[1380 * 4];

/* init variables */
int nb_couples;
int *couple_next;
int *couple_first;
int *couple_score;
int *couple_nb;

extern void init_plugin (int);

unsigned short *try_perm_asm (void);
void correlation (unsigned short *);
int decode_nagra (unsigned short *perm,
                  void **lines, void **lines_wss, int xsize);
inline void full_blueline_filter(unsigned char *src, unsigned char **lines_e, unsigned char **lines_o, unsigned short*perm_e, unsigned short*perm_o, int xsize_src, int ysize);
inline void half_blueline_filter(unsigned char *src, unsigned char **lines, unsigned short*perm, int xsize_src, int ysize);

void (*putline_pal) (int i1, int i2, int offset32, int y, int perm_y, int xsize, void *p2, void *p1);

void (*putlinedup_pal) (int i1, int i2, int offset32, int y, int perm_y, int xsize, void *p2, void *p1, void *p2dup);

void (*putline_secam) (int xsize, void *p2, void *p1);

void (*putlinedup_secam) (int xsize, void *p2, void *p1, void *p2dup);

void
read_keys (void)
{
  FILE *key_fp;
  int i, tmp;
  char key_file[255];

  sprintf (key_file, "%s/%s", user_dir, "key.txt");

  if ((key_fp = fopen (key_file, "r")) == (FILE *) NULL)
    {
      decode = 0;
      //fprintf(stderr, "Can't open %s\nExiting.\n", key_file);
      for (i = 0; i < 256; i++)
        {
          table_keys[i] = 0;
        }
      //exit(1);
    }
  else
    {
      fprintf (stdout, "Reading %s\n", key_file);
      for (i = 0; i < 256; i++)
        {
          fscanf (key_fp, "%d\n", &tmp);
          table_keys[i] = (char) tmp;
          //printf("key[%d] = %d\n", i, (int)table_keys[i]);
        }
      fclose (key_fp);

      prep_tabs ();
      prep_tabs2 ();
      init_plugin (grabber);
    }

}

inline void
Black_Matrix(unsigned char **lines, int width)
{
//#define C_ALGO1 1
//#define C_ALGO2 1
//#define C_ALGO3 1
//#define ASM_ALGO2 1
#define ASM_ALGO3 1

#ifdef C_ALGO1

  // This algorithm works pretty well when there are black borders
  // However it makes a lot of false detection when there isn't any
  // black border and the picture is somewhat dark

  int i;
  int y;
  unsigned long sumY;
  unsigned char *yuv;

  for (y=0;y<287;y++)
    {
      BlackSet[y] = 0;
      sumY = 0;
      yuv = lines[y];
      for (i=0; i<(width/1);i++) // Test only first quarter of the line to speed up the process
        {
          sumY += *yuv;
          yuv += 2;
        }
      if (sumY < (width/1)*45) // individual Y black threshold set to 45
        {
          BlackSet[y] = 1;
        }
    }
#endif

#ifdef C_ALGO2

  // This algorithm works pretty well when there are black borders
  // And it doesn't too much false detection...

  int i;
  int y;
  unsigned char *yuv;

  for (y=0;y<287;y++)
    {
      BlackSet[y] = 1;
      yuv = lines[y];
      for (i = 0; i < width; i++)
        {
          if (*yuv > 46)
            {
              BlackSet[y] = 0;
              break;
            }
          yuv += 2;
        }
    }
#endif

#ifdef C_ALGO3
#define TESTPIXEL 32
  int i;
  int y;
  unsigned char *yuv;
  //int FirstWidth = TESTPIXEL;
  //int nPixelSchritt = width/TESTPIXEL/2;
  int testpixel;
  int step;

  step = (width/4); // 4 pixels at a time

  if (step/TESTPIXEL > 0)
    {
      // we test TESTPIXEL samples of 4 pixels regularly spaced and centered on the line
      step = step/TESTPIXEL;
      testpixel = TESTPIXEL;
    }
  else
    {
      // there are less of TESTPIXEL samples of 4 pixel on the line
      // test the whole line...
      testpixel = step;
      step = 1;
    }

  //printf("step = %d, testpixel = %d\n", step, testpixel);

  for (y=0;y<287;y++)
    {
      BlackSet[y] = 1;
      yuv = lines[y]+8*(step/2);
      for (i = 0; i < testpixel; i ++)
        {
          if (yuv[0] > 46)
            {
              BlackSet[y] = 0;
              break;
            }
          else if (yuv[2] > 46)
            {
              BlackSet[y] = 0;
              break;
            }
          else if (yuv[4] > 46)
            {
              BlackSet[y] = 0;
              break;
            }
          else if (yuv[6] > 46)
            {
              BlackSet[y] = 0;
              break;
            }

          yuv += 8*step;
        }
    }
#endif

#ifdef ASM_ALGO2

  // This is the same as C_ALGO2

 __asm__ __volatile__ (

// This function is defined as a macro in order to use the \@ functionnality
// which gives a different value to the @ each time it is encountered
// within the same macro.
// This allows to trick the compiler when it really inlines the function
// and therefore avoid multiple definition of hand written labels which
// would then cause a compiler failure... tricky, tricky, tricky...
 
".macro M_Black_Matrix\n\t"
        "movl     %0, %%eax              \n\t" // lines
        "movl     (%%eax), %%edi         \n\t" // edi = lines[0]

        "movl     %1, %%ecx              \n\t" // width (nb of pixels within a line)
        "shrl     $2, %%ecx              \n\t"
        "movd     %%ecx,%%mm1            \n\t" // make a copy of width/4 in mm1

        "movq     CurrentLowValue, %%mm2 \n\t"
        "movq     nMaskY, %%mm3          \n\t"

        "movl     $287, %%edx            \n\t"
        "movl     $0, BlackSet(,%%edx,4) \n\t" // BlackSet[4*edx] = 0

        "jmp      Black_Matrix.MoreToGet\\@ \n\t"

".align 16\n\t"

    "Black_Matrix.NextLine\\@:       \n\t"
        "movd     %%mm1, %%ecx           \n\t" // reset ecx to width
        "movl     (%%eax,%%edx,4), %%edi \n\t" // edi = lines[4*edx] 
        "movl     $0, BlackSet(,%%edx,4) \n\t" // BlackSet[4*edx] = 0

    "Black_Matrix.MoreToGet\\@:       \n\t"
        "movq     (%%edi), %%mm0         \n\t" // mm0 = *(edi), i.e.: mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
        "pand     %%mm3, %%mm0           \n\t" // mm0 = mm0 & nmaskY, mm0 = 00 Y3 00 Y2 00 Y1 00 Y0
        "psubusb  %%mm2, %%mm0           \n\t" // mm0 = ByteUnsignedWithSaturation( mm0 - CurrentLowValue)
                                               // i.e. mm0 = 00 Y3' 00 Y2' 00 Y1' 00 Y0'

        "addl     $8, %%edi              \n\t" // edi += 8

        "packsswb %%mm0, %%mm0           \n\t" // mm0 = 00 00 00 00 Y3' Y2' Y1' Y0'

        "movd     %%mm0, %%ebx           \n\t" // ebx = Y3' Y2' Y1' Y0'
        "cmpl     $0, %%ebx              \n\t"       // if (ebx == 0)
        "jnz      Black_Matrix.NichtSchwarz\\@ \n\t" //   goto Black_Matrix.NichtSchwarz

        "loop     Black_Matrix.MoreToGet\\@ \n\t"    // ecx--; if (ecx>0) goto Black_Matrix.MoreToGet

        "movl     $1, BlackSet(,%%edx,4) \n\t"       // BlackSet[4*edx] = 1
        //"incl    $nb_ligne_noire        \n\t"

    "Black_Matrix.NichtSchwarz\\@:       \n\t"
        "decl     %%edx                  \n\t"
        "jne      Black_Matrix.NextLine\\@  \n\t" //   goto Black_Matrix.NextLine

    "Black_Matrix.Ende\\@:              \n\t"
".endm\n\t"

"M_Black_Matrix\n\t"

        "emms\n\t"
        :        /* no output */
        :        /* input */
        "m" (lines),    /* %0 */
        "m" (width)     /* %1 */
        :        /* modified regs */
        "eax", "ebx", "ecx", "edx", "edi", "esi"
        /*, "mm0", "mm1", "mm2", "mm3" */
  );
#endif

#ifdef ASM_ALGO3

  // This is the same as C_ALGO3

#define TESTPIXEL 32
 int step;
 int testpixel;

  step = (width/4); // 4 pixels at a time

  if (step/TESTPIXEL > 0)
    {
      // we test TESTPIXEL samples of 4 pixels regularly spaced and centered on the line
      step = step/TESTPIXEL;
      testpixel = TESTPIXEL;
    }
  else
    {
      // there are less of TESTPIXEL samples of 4 pixel on the line
      // test the whole line...
      testpixel = step;
      step = 1;
    }

 __asm__ __volatile__ (

// This function is defined as a macro in order to use the \@ functionnality
// which gives a different value to the @ each time it is encountered
// within the same macro.
// This allows to trick the compiler when it really inlines the function
// and therefore avoid multiple definition of hand written labels which
// would then cause a compiler failure... tricky, tricky, tricky...

".macro M_Black_Matrix\n\t"
        "movq     CurrentLowValue, %%mm5 \n\t"
        "movq     nMaskY, %%mm4          \n\t"

        "xorl     %%edx, %%edx            \n\t"
        "movl     $0, BlackSet(,%%edx,4) \n\t" // BlackSet[4*edx] = 0

        "movl     %0, %%eax              \n\t" // lines
        "movl     (%%eax,%%edx,4), %%edi \n\t" // edi = lines[0]

        "movl     %1, %%ecx              \n\t" // testpixel

        "movl     %2, %%eax              \n\t" // step
        "shrl     $1, %%eax              \n\t" // eax = step/2
        "movl     %%eax, %%esi           \n\t" // Save step/2 in esi

        "jmp      Black_Matrix.MoreToGet\\@ \n\t"

".align 16\n\t"

    "Black_Matrix.NextLine\\@:       \n\t"
        "movl     $0, BlackSet(,%%edx,4) \n\t" // BlackSet[4*edx] = 0
        "movl     %0, %%eax              \n\t" // lines
        "movl     %1, %%ecx              \n\t" // reset ecx to testpixel
        "movl     (%%eax,%%edx,4), %%edi \n\t" // edi = lines[4*edx] 
        "movl     %%esi, %%eax           \n\t" // restore step/2 in eax
    "Black_Matrix.MoreToGet\\@:       \n\t"
        "movq     (%%edi, %%eax, 8), %%mm0         \n\t" // mm0 = *(edi), i.e.: mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
        "addl     %2, %%eax              \n\t" // eax += step

        "pand     %%mm4, %%mm0           \n\t" // mm0 = mm0 & nmaskY, mm0 = 00 Y3 00 Y2 00 Y1 00 Y0
        "psubusb  %%mm5, %%mm0           \n\t" // mm0 = ByteUnsignedWithSaturation( mm0 - CurrentLowValue)
                                               // i.e. mm0 = 00 Y3' 00 Y2' 00 Y1' 00 Y0'

        "packsswb %%mm0, %%mm0           \n\t" // mm0 = 00 00 00 00 Y3' Y2' Y1' Y0'

        "movd     %%mm0, %%ebx           \n\t" // ebx = Y3' Y2' Y1' Y0'
        "cmpl     $0, %%ebx              \n\t"       // if (ebx == 0)
        "jnz      Black_Matrix.NichtSchwarz\\@ \n\t" //   goto Black_Matrix.NichtSchwarz

        "loop     Black_Matrix.MoreToGet\\@ \n\t"    // ecx--; if (ecx>0) goto Black_Matrix.MoreToGet

        "movl     $1, BlackSet(,%%edx,4) \n\t"       // BlackSet[4*edx] = 1
        //"incl    AnzahlSchwarzeZeilen    \n\t"

    "Black_Matrix.NichtSchwarz\\@:       \n\t"
        "incl     %%edx                  \n\t"       // edx++
        "cmpl     $287, %%edx            \n\t"
        "jl       Black_Matrix.NextLine\\@  \n\t" //   goto Black_Matrix.NextLine

    "Black_Matrix.Ende\\@:              \n\t"
".endm\n\t"

"M_Black_Matrix\n\t"

        "emms\n\t"
        :        /* no output */
        :        /* input */
        "m" (lines),     /* %0 */
        "m" (testpixel), /* %1 */
        "m" (step)       /* %2 */
        :        /* modified regs */
        "eax", "ebx", "ecx", "edx", "edi", "esi"
        /*, "mm0", "mm1", "mm2", "mm3" */
  );
#endif
}

inline int
find_ybar(unsigned short *perm, int width, int even)
{
  int i;
  int m = 0;
  static int even_value = 0;
  static int odd_value = 0;


  for(i=0;i<68;i++)
    {
      if ( BlackSet[perm[i]] == 1)
        m++;
    }  

  for(i=287-68;i<287;i++)
    {
      if ( BlackSet[perm[i]] == 1)
        m++;
    }

  if (even)
    {
      if ( blackborder_tolerance*abs(2*even_value - m) > 2*even_value) // don't care of variation less than 1/TOLERANCE*100 %
        {
          // if more than 1/TOLERANCE*100 % variation, take into account
          // but with a first order low pass filter
          even_value = (7*m/2 + 3*even_value)/10;
        }
      return even_value;
    }
  else
    {
      if (blackborder_tolerance*abs(2*odd_value - m) > 2*odd_value) // don't care of variation less than 1/TOLERANCE*100 %
        {
          // if more than 1/TOLERANCE*100 % variation, take into account
          // but with a first order low pass filter
          odd_value = (7*m/2 + 3*odd_value)/10;
        }
      return odd_value;
    }

}

//********************************************************************
//                      H A L F   F R A M E   R G B
//********************************************************************
void
decode_halfframe_RGB (unsigned char *dest,
                  unsigned char *src, int xsize, int xsize_src, int ysize,
                  int dest_xsize)
{
  int i, y;
  int i1, i2;
  unsigned short perm[288];
  short *p2 = NULL;
  unsigned char *p1;

  unsigned char *lines[288];
  unsigned char *lines_wss[32];
  int count;
  int xoffset;
  int offset32;
  int secam;
  int yd;

  static int pbUpdateBuffer;
  static int pbViewBuffer;
  static int traitement_OK;

  
  //printf("xsize = %d, xsize_src = %d, ysize = %d, dest_xsize = %d, YSIZE = %d\n", xsize, xsize_src, ysize, dest_xsize, YSIZE);

  secam = (cur_norm == TVNORM_SECAM);

  xsize_src *= 2;
  //printf ("xsize_src = %d\n", xsize_src);

  xsize *= 2;
  //printf ("xsize = %d\n", xsize);

  xoffset = (xsize_src - xsize) & ~3;
  //printf ("xoffset = %d\n", xoffset);

  if (bpp == 24)
    {
      dest_xsize *= 2;
      putline_pal      = putline_PAL_RGB32;
      putlinedup_pal   = putlinedup_PAL_RGB32;
      putline_secam    = putline_SECAM_RGB32;
      putlinedup_secam = putlinedup_SECAM_RGB32;
    }
  else
    {
      putline_pal      = putline_PAL_RGB16;
      putlinedup_pal   = putlinedup_PAL_RGB16;
      putline_secam    = putline_SECAM_RGB16;
      putlinedup_secam = putlinedup_SECAM_RGB16;
    }
  //printf ("dest_xsize = %d\n", dest_xsize);


  //********************************************************************
  //                   HALF FRAME RGB: NOT NAGRA CODED
  //********************************************************************
  if (!nagra_coded)
    {
      // it doesn't matter if we use putline_pal or putline_secam as lines are not scrambled
      // putline_secam should just be a little bit faster...

      if (ybar_auto)
        ybar = 1;

      yd = (ybar*ysize)/(YSIZE*2);
      p2 = (short *) dest + (yd * dest_xsize);
      p1 = src + xoffset + (ybar * xsize_src); // should be (ybar/2 * 2*xsize_src)

      if (ysize >= YSIZE)
        {
          // resize: make it bigger
          y = ybar/2;
          count = ysize / 2;
          for (i = yd; i < (ysize - yd); i++)
            {
              count += YSIZE;
              if (count - ysize + YSIZE < ysize)
                {
                  //putlinedup_pal (0, 0, 0, y, y + 32, xsize, p2, p1, p2 + dest_xsize);
                  putlinedup_secam(xsize, p2, p1, p2 + dest_xsize);
                  y++;
                  i++;
                  count = count - ysize + YSIZE;
                  p2 += 2 * dest_xsize;
                  p1 += xsize_src * 2;
                }
              else
                {
                  //putline_pal (0, 0, 0, y, y + 32, xsize, p2, p1);
                  putline_secam(xsize, p2, p1);
                  y++;
                  count -= ysize;
                  p2 += dest_xsize;
                  p1 += xsize_src * 2;
                }
            }
        }
      else
        {
          // resize: make it smaller
          count = YSIZE / 2;
          for (y = ybar/2; y < (YSIZE - ybar/2); y++)
            {
              count += ysize;
              if (count >= YSIZE)
                {
                  // output line
                  //putline_pal (0, 0, 0, y, y, xsize, p2, p1);
                  putline_secam(xsize, p2, p1);
                  count -= YSIZE;
                  p2 += dest_xsize;
                }
              p1 += xsize_src * 2;
            }
        }
      return;
    } // if (!nagra_coded)

    if(number_couples==4)
  {

  meuhmeuh->Full_Field=0/*!decode_trame_impaire*/;
  meuhmeuh->CurrentFrame=even;
  meuhmeuh->CurrentX=xsize_src/2;
  meuhmeuh->MovieBoost=ybar/2-1;

  if (meuhmeuh->MovieBoost<0) meuhmeuh->MovieBoost = 0;

  for(i=0;i<288;i++)
  {
    meuhmeuh->EvenLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i ) * xsize_src] ;
    meuhmeuh->OddLines [meuhmeuh->CurrentFrame][i] = (short *) &src[(2 * i + 1 ) * xsize_src];

  }


  *(meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame])=0;
  *(meuhmeuh->OutOddLines [meuhmeuh->CurrentFrame])=0;

   // Paire
  meuhmeuh->DoStuff(0,&pbUpdateBuffer,&pbViewBuffer);

  // impaire
  meuhmeuh->DoStuff(1,&pbUpdateBuffer,&pbViewBuffer);
  traitement_OK = pbUpdateBuffer;

  if (!traitement_OK) return;


 yd = (ybar*ysize)/(YSIZE*2);
  p2 = (short *) dest + (yd * dest_xsize);


	if (ysize > YSIZE)
        {
          // resize: make it bigger
          y = ybar/2;
          count = ysize / 2;

          for (i = yd; i < (ysize - yd); i++)
            {
              count += YSIZE;
              p1 = (char *) meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame][yd] + xoffset;

              if (count - ysize + YSIZE < ysize)
                {
                  // 2 lines in one shot
                  putlinedup_secam (xsize, p2, p1, p2 + dest_xsize);
                  y++;
                  i++;
                  count = count - ysize + YSIZE;
                  p2 += 2 * dest_xsize;
                }
              else
                {
                  putline_secam (xsize, p2, p1);
                  y++;
                  count -= ysize;
                  p2 += dest_xsize;
                }
            }
        }
      else
        {
          // resize: make it smaller
          count = YSIZE / 2;
          for (y = ybar/2; y < (YSIZE - ybar/2); y++)
            {
              count += ysize;
              if (count >= YSIZE)
                {
                  // ouput line
                  p1 = (char *) meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame][y] + xoffset;
                  putline_secam (xsize, p2, p1);
                  count -= YSIZE;
                  p2 += dest_xsize;
                }
              else
                {
                  // discard line
                  p1 += xsize;
                }
            }
        }    

  }
  else
  {


  //********************************************************************
  //                      HALF FRAME RGB: NAGRA CODED
  //********************************************************************

  for (i = 0; i < 32; i++)
    lines_wss[i] = linebuf + i * xsize_src;

  // use_wss_line=1; 
  if (use_wss_line)                // is the WideScreeLine to be used ?
    {
      /* wenn, dann erstes Halbbild dekodieren, da Zeile 23 mit der WSS-Line
       * im ersten Halbbild liegt */

      // die ersten 32 Zeilen wurden bereits im letzten Frame gesendet,
      // deshalb die in 'linebuf' gesicherten Zeilen nehmen, 
      // ein Dreifachbuffer wre aber besser */
      for (i = 0; i < 32; i++)
        lines[i] = linebuf + i * xsize_src;

      for (i = 0; i < 255; i++)
        lines[i + 32] = &src[(2 * i) * xsize_src];
      //Hier??  burst_phase=1-burst_phase;
    }
  else
    {
      /* ansonsten zweites Halbbild */
      for (i = 0; i < 32; i++)
        lines[i] = &src[(2 * (288 - 33 + i)) * xsize_src];

      for (i = 0; i < 255; i++)
        lines[i + 32] = &src[(2 * i + 1) * xsize_src];
    }

  /* dekodieren  */
  decode_nagra (perm, (void **) lines, (void **) lines_wss, xsize_src / 2);

  if (ybar_auto)
    {
      if (bbfrcount > 25*5) // update ybar every 5 secs (assuming there is 25 fps)
        bbfrcount = 0;

      if (bbfrcount < 10) // update only using 10 frames
        {
          Black_Matrix(lines, xsize_src/2);
          ybar = 2*find_ybar(perm, xsize_src/2, 1);
          if (ybar == 0)
            ybar = 1;
        }
      bbfrcount++;
    }

#ifndef DISABLE_ALL_FILTERS
  if (secam)
    half_blueline_filter(src, lines, perm, xsize_src, ysize);
#endif

  if (use_wss_line)                // die WideScreeLine wird verwendet ?
    {
      burst_phase = 1 - burst_phase;
      // erste Zeile lschen
      for (i = 0; i < xsize_src / 4; i++)
        *(((unsigned int *) lines[perm[0]]) + i) = 0x80008000;    //notwendig?
      // memset(lines[perm[0]],0,xsize*2);
    }

  /* und die Zeilen in der richtigen Reihenfolge nach *dest kopieren, dabei
   * wird auch die Y-Richtung skaliert
   */
      
  yd = (ybar*ysize)/(YSIZE*2); 
  p2 = (short *) dest + (yd * dest_xsize);


  if (secam)
  //********************************************************************
  //                  HALF FRAME RGB: SECAM rendering
  //********************************************************************
    {
      if (ysize > YSIZE)
        {
          // resize: make it bigger
          y = ybar/2;
          count = ysize / 2;

          for (i = yd; i < (ysize - yd); i++)
            {
              count += YSIZE;
              p1 = lines[perm[y]] + xoffset;

              if (count - ysize + YSIZE < ysize)
                {
                  // 2 lines in one shot
                  putlinedup_secam (xsize, p2, p1, p2 + dest_xsize);
                  y++;
                  i++;
                  count = count - ysize + YSIZE;
                  p2 += 2 * dest_xsize;
                }
              else
                {
                  putline_secam (xsize, p2, p1);
                  y++;
                  count -= ysize;
                  p2 += dest_xsize;
                }
            }
        }
      else
        {
          // resize: make it smaller
          count = YSIZE / 2;
          for (y = ybar/2; y < (YSIZE - ybar/2); y++)
            {
              count += ysize;
              if (count >= YSIZE)
                {
                  // ouput line
                  p1 = lines[perm[y]] + xoffset;
                  putline_secam (xsize, p2, p1);
                  count -= YSIZE;
                  p2 += dest_xsize;
                }
              else
                {
                  // discard line
                  p1 += xsize;
                }
            }
        }
    }
  else // (if secam)
  //********************************************************************
  //                  HALF FRAME RGB: PAL rendering
  //********************************************************************
      {
        if (ysize > YSIZE)
          {
            // resize: make it bigger
            y = ybar/2;
            count = ysize / 2;

            for (i = yd; i < (ysize - yd); i++)
              {
                count += YSIZE;
                p1 = lines[perm[y]] + xoffset;

                if (count - ysize + YSIZE < ysize)
                  {
                    // 2 lines in one shot
                    offset32 = 0x1a;

                    i1 = y & 1;
                    if (burst_phase == 0)
                      i1 ^= 1;

                    i2 = perm[y] & 1;
                    if (use_wss_line)
                      {
                        if (perm[y] < 32)
                          i2 ^= 1;
                        offset32 = 0x19;
                      }
                    if (burst_phase == 0)
                      i2 ^= 1;

                    putlinedup_pal (i1, i2, offset32, y, perm[y], xsize, p2, p1,
                                p2 + dest_xsize);

                    y++;
                    i++;
                    count = count - ysize + YSIZE;
                    p2 += 2 * dest_xsize;
                  }
                else
                  {

                    offset32 = 0x1a;

                    i1 = y & 1;
                    if (burst_phase == 0)
                      i1 ^= 1;

                    i2 = perm[y] & 1;
                    if (use_wss_line)
                      {
                        if (perm[y] < 32)
                          i2 ^= 1;
                        offset32 = 0x19;
                      }
                    if (burst_phase == 0)
                      i2 ^= 1;
                    putline_pal (i1, i2, offset32, y, perm[y], xsize, p2, p1);

                    y++;
                    count -= ysize;
                    p2 += dest_xsize;
                  }
              }
          }
        else
          {
            // resize: make it smaller
            count = YSIZE / 2;
            for (y = ybar/2; y < (YSIZE - ybar/2); y++)
              {
                count += ysize;
                if (count >= YSIZE)
                  {
                    // ouput line
                    p1 = lines[perm[y]] + xoffset;
                    offset32 = 0x1a;

                    i1 = y & 1;
                  if (burst_phase == 0)
                    i1 ^= 1;

                  i2 = perm[y] & 1;
                  if (use_wss_line)
                    {
                      if (perm[y] < 32)
                        i2 ^= 1;
                      offset32 = 0x19;
                    }
                  if (burst_phase == 0)
                    i2 ^= 1;

                  putline_pal (i1, i2, offset32, y, perm[y], xsize, p2, p1);

                  count -= YSIZE;
                  p2 += dest_xsize;
                  }
                else
                  {
                    // discard line
                    p1 += xsize;
                  }
              }
          }
      }

  /* save 32 lines for next image */
  for (i = 0; i < 32; i++)
    fast_memcpy (linebuf + i * xsize_src, &src[(511 + i * 2) * xsize_src],
            xsize_src);
 }           
}


//********************************************************************
//                      H A L F   F R A M E   Y U V   S W
//********************************************************************
void
decode_halfframe_YUV_sw (unsigned char *dest,
                  unsigned char *src, int xsize, int xsize_src, int ysize,
                  int dest_xsize)
{
  int i, y;
  int i1, i2;
  unsigned short perm[288];
  short *p2 = NULL;
  unsigned char *p1;

  unsigned char *lines[288];
  unsigned char *lines_wss[32];
  int count;
  int xoffset;
  int offset32;
  int secam;
  int yd;

  static int pbUpdateBuffer;
  static int pbViewBuffer;
  static int traitement_OK;

  
  //printf("xsize = %d, xsize_src = %d, ysize = %d, dest_xsize = %d, YSIZE = %d\n", xsize, xsize_src, ysize, dest_xsize, YSIZE);

  secam = (cur_norm == TVNORM_SECAM);

  xsize_src *= 2;
  //printf ("xsize_src = %d\n", xsize_src);

  xsize *= 2;
  //printf ("xsize = %d\n", xsize);

  xoffset = (xsize_src - xsize) & ~3;
  //printf ("xoffset = %d\n", xoffset);

  //printf ("dest_xsize = %d\n", dest_xsize);


  //********************************************************************
  //                 HALF FRAME YUV SW: NOT NAGRA CODED
  //********************************************************************
  if (!nagra_coded)
    {
      if (ybar_auto)
        ybar = 1;

      yd = (ybar*ysize)/(YSIZE*2); 
      p2 = (short *) dest + (yd * dest_xsize);
      p1 = src + xoffset + (ybar * xsize_src); // should be (ybar/2 * 2*xsize_src)

      if (ysize >= YSIZE)
        {
          // resize: make it bigger
          y = ybar/2;
          count = ysize / 2;
          for (i = yd; i < (ysize - yd); i++)
            {
              count += YSIZE;
              if (count - ysize + YSIZE < ysize)
                {
                  //putlinedup_pal (0, 0, 0, y, y + 32, xsize, p2, p1, p2 + dest_xsize);
                  //putlinedup_secam(xsize, p2, p1, p2 + dest_xsize);
                  fast_memcpy(p2, p1, xsize);
                  fast_memcpy(p2 + dest_xsize, p1, xsize);
                  y++;
                  i++;
                  count = count - ysize + YSIZE;
                  p2 += 2 * dest_xsize;
                  p1 += xsize_src * 2;
                }
              else
                {
                  //putline_pal (0, 0, 0, y, y + 32, xsize, p2, p1);
                  //putline_secam(xsize, p2, p1);
                  fast_memcpy(p2, p1, xsize);
                  y++;
                  count -= ysize;
                  p2 += dest_xsize;
                  p1 += xsize_src * 2;
                }
            }
        }
      else
        {
          // resize: make it smaller
          count = YSIZE / 2;
          for (y = ybar/2; y < (YSIZE - ybar/2); y++)
            {
              count += ysize;
              if (count >= YSIZE)
                {
                  // output line
                  //putline_pal (0, 0, 0, y, y, xsize, p2, p1);
                  //putline_secam(xsize, p2, p1);
                  fast_memcpy(p2, p1, xsize);
                  count -= YSIZE;
                  p2 += dest_xsize;
                }
              p1 += xsize_src * 2;
            }
        }
      return;
    } // if (!nagra_coded)


    
     if(number_couples==4)
  {

  meuhmeuh->Full_Field=0/*!decode_trame_impaire*/;
  meuhmeuh->CurrentFrame=even;
  meuhmeuh->CurrentX=xsize_src/2;
  meuhmeuh->MovieBoost=ybar/2-1;

  if (meuhmeuh->MovieBoost<0) meuhmeuh->MovieBoost = 0;

  for(i=0;i<288;i++)
{
    meuhmeuh->EvenLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i) * xsize_src] ;
    meuhmeuh->OddLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i+1) * xsize_src];

}


  *(meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame])=0;
  *(meuhmeuh->OutOddLines [meuhmeuh->CurrentFrame])=0;


   // Paire
  meuhmeuh->DoStuff(0,&pbUpdateBuffer,&pbViewBuffer);

  // impaire
  meuhmeuh->DoStuff(1,&pbUpdateBuffer,&pbViewBuffer);
  traitement_OK = pbUpdateBuffer;

  if (!traitement_OK) return;


 yd = (ybar*ysize)/(YSIZE*2);
  p2 = (short *) dest + (yd * dest_xsize);


  if (ysize > YSIZE)
        {
          // resize: make it bigger
          y = ybar/2;
          count = ysize / 2;

          for (i = yd; i < (ysize - yd); i++)
            {
              count += YSIZE;
              p1 = (char *) meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame][yd] + xoffset;

              if (count - ysize + YSIZE < ysize)
                {
                  // 2 lines in one shot
                  //putlinedup_secam (xsize, p2, p1, p2 + dest_xsize);
                  fast_memcpy(p2, p1, xsize);
                  fast_memcpy(p2 + dest_xsize, p1, xsize);
                  y++;
                  i++;
                  count = count - ysize + YSIZE;
                  p2 += 2 * dest_xsize;
                }
              else
                {
                  //putline_secam (xsize, p2, p1);
                  fast_memcpy(p2, p1, xsize);
                  y++;
                  count -= ysize;
                  p2 += dest_xsize;
                }
            }
        }
      else
        {
          // resize: make it smaller
          count = YSIZE / 2;
          for (y = ybar/2; y < (YSIZE - ybar/2); y++)
            {
              count += ysize;
              if (count >= YSIZE)
                {
                  // ouput line
                  p1 = (char *) meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame][y] + xoffset;
                  //putline_secam (xsize, p2, p1);
                  fast_memcpy(p2, p1, xsize);
                  count -= YSIZE;
                  p2 += dest_xsize;
                }
              else
                {
                  // discard line
                  p1 += xsize;
                }
            }
        }

    }
    else
    {    



  //********************************************************************
  //                    HALF FRAME YUV SW: NAGRA CODED
  //********************************************************************

  for (i = 0; i < 32; i++)
    lines_wss[i] = linebuf + i * xsize_src;

  // use_wss_line=1; 
  if (use_wss_line)                // is the WideScreeLine to be used ?
    {
      /* wenn, dann erstes Halbbild dekodieren, da Zeile 23 mit der WSS-Line
       * im ersten Halbbild liegt */

      // die ersten 32 Zeilen wurden bereits im letzten Frame gesendet,
      // deshalb die in 'linebuf' gesicherten Zeilen nehmen, 
      // ein Dreifachbuffer wre aber besser */
      for (i = 0; i < 32; i++)
        lines[i] = linebuf + i * xsize_src;

      for (i = 0; i < 255; i++)
        lines[i + 32] = &src[(2 * i) * xsize_src];
      //Hier??  burst_phase=1-burst_phase;
    }
  else
    {
      /* ansonsten zweites Halbbild */
      for (i = 0; i < 32; i++)
        lines[i] = &src[(2 * (288 - 33 + i)) * xsize_src];

      for (i = 0; i < 255; i++)
        lines[i + 32] = &src[(2 * i + 1) * xsize_src];
    }

  /* dekodieren  */
  decode_nagra (perm, (void **) lines, (void **) lines_wss, xsize_src / 2);

  if (ybar_auto)
    {
      if (bbfrcount > 25*5) // update ybar every 5 secs (assuming there is 25 fps)
        bbfrcount = 0;

      if (bbfrcount < 10) // update only using 10 frames
        {
          Black_Matrix(lines, xsize_src/2);
          ybar = 2*find_ybar(perm, xsize_src/2, 1);
          if (ybar == 0)
            ybar = 1;
        }
      bbfrcount++;
    }

#ifndef DISABLE_ALL_FILTERS
  if (secam)
    half_blueline_filter(src, lines, perm, xsize_src, ysize);
#endif

  if (use_wss_line)                // die WideScreeLine wird verwendet ?
    {
      burst_phase = 1 - burst_phase;
      // erste Zeile lschen
      for (i = 0; i < xsize_src / 4; i++)
        *(((unsigned int *) lines[perm[0]]) + i) = 0x80008000;    //notwendig?
      // memset(lines[perm[0]],0,xsize*2);
    }

  /* und die Zeilen in der richtigen Reihenfolge nach *dest kopieren, dabei
   * wird auch die Y-Richtung skaliert
   */
      
  yd = (ybar*ysize)/(YSIZE*2); 
  p2 = (short *) dest + (yd * dest_xsize);


  if (secam)
  //********************************************************************
  //                HALF FRAME YUV SW: SECAM rendering
  //********************************************************************
    {
      if (ysize > YSIZE)
        {
          // resize: make it bigger
          y = ybar/2;
          count = ysize / 2;

          for (i = yd; i < (ysize - yd); i++)
            {
              count += YSIZE;
              p1 = lines[perm[y]] + xoffset;

              if (count - ysize + YSIZE < ysize)
                {
                  // 2 lines in one shot
                  //putlinedup_secam (xsize, p2, p1, p2 + dest_xsize);
                  fast_memcpy(p2, p1, xsize);
                  fast_memcpy(p2 + dest_xsize, p1, xsize);
                  y++;
                  i++;
                  count = count - ysize + YSIZE;
                  p2 += 2 * dest_xsize;
                }
              else
                {
                  //putline_secam (xsize, p2, p1);
                  fast_memcpy(p2, p1, xsize);
                  y++;
                  count -= ysize;
                  p2 += dest_xsize;
                }
            }
        }
      else
        {
          // resize: make it smaller
          count = YSIZE / 2;
          for (y = ybar/2; y < (YSIZE - ybar/2); y++)
            {
              count += ysize;
              if (count >= YSIZE)
                {
                  // ouput line
                  p1 = lines[perm[y]] + xoffset;
                  //putline_secam (xsize, p2, p1);
                  fast_memcpy(p2, p1, xsize);
                  count -= YSIZE;
                  p2 += dest_xsize;
                }
              else
                {
                  // discard line
                  p1 += xsize;
                }
            }
        }
    }
  else // (if secam)
  //********************************************************************
  //                 HALF FRAME YUV SW: PAL rendering
  //********************************************************************
      {
        if (ysize > YSIZE)
          {
            // resize: make it bigger
            y = ybar/2;
            count = ysize / 2;

            for (i = yd; i < (ysize - yd); i++)
              {
                count += YSIZE;
                p1 = lines[perm[y]] + xoffset;

                if (count - ysize + YSIZE < ysize)
                  {
                    // 2 lines in one shot
                    offset32 = 0x1a;

                    i1 = y & 1;
                    if (burst_phase == 0)
                      i1 ^= 1;

                    i2 = perm[y] & 1;
                    if (use_wss_line)
                      {
                        if (perm[y] < 32)
                          i2 ^= 1;
                        offset32 = 0x19;
                      }
                    if (burst_phase == 0)
                      i2 ^= 1;

                    //putlinedup_pal (i1, i2, offset32, y, perm[y], xsize, p2, p1, p2 + dest_xsize);
                    putline_PAL_YVU (i1, i2, offset32, y, perm[y], xsize, p2, p1);
                    putline_PAL_YVU (i1, i2, offset32, i, perm[y], xsize, p2 + dest_xsize, p1);

                    y++;
                    i++;
                    count = count - ysize + YSIZE;
                    p2 += 2 * dest_xsize;
                  }
                else
                  {

                    offset32 = 0x1a;

                    i1 = y & 1;
                    if (burst_phase == 0)
                      i1 ^= 1;

                    i2 = perm[y] & 1;
                    if (use_wss_line)
                      {
                        if (perm[y] < 32)
                          i2 ^= 1;
                        offset32 = 0x19;
                      }
                    if (burst_phase == 0)
                      i2 ^= 1;
                    //putline_pal (i1, i2, offset32, y, perm[y], xsize, p2, p1);
                    putline_PAL_YVU (i1, i2, offset32, y, perm[y], xsize, p2, p1);

                    y++;
                    count -= ysize;
                    p2 += dest_xsize;
                  }
              }
          }
        else
          {
            // resize: make it smaller
            count = YSIZE / 2;
            for (y = ybar/2; y < (YSIZE - ybar/2); y++)
              {
                count += ysize;
                if (count >= YSIZE)
                  {
                    // ouput line
                    p1 = lines[perm[y]] + xoffset;
                    offset32 = 0x1a;

                    i1 = y & 1;
                  if (burst_phase == 0)
                    i1 ^= 1;

                  i2 = perm[y] & 1;
                  if (use_wss_line)
                    {
                      if (perm[y] < 32)
                        i2 ^= 1;
                      offset32 = 0x19;
                    }
                  if (burst_phase == 0)
                    i2 ^= 1;

                  //putline_pal (i1, i2, offset32, y, perm[y], xsize, p2, p1);
                  putline_PAL_YVU (i1, i2, offset32, y, perm[y], xsize, p2, p1);

                  count -= YSIZE;
                  p2 += dest_xsize;
                  }
                else
                  {
                    // discard line
                    p1 += xsize;
                  }
              }
          }
      }

  /* save 32 lines for next image */
  for (i = 0; i < 32; i++)
    fast_memcpy (linebuf + i * xsize_src, &src[(511 + i * 2) * xsize_src],
            xsize_src);
    }
}



//********************************************************************
//                   H A L F   F R A M E   Y U V   H W
//********************************************************************
void
decode_halfframe_YUV_hw (unsigned char *dest,
                  unsigned char *src, int xsize, int xsize_src, int ysize,
                  int dest_xsize)
{
  int i, y;
  int i1, i2;
  unsigned short perm[288];
  unsigned char *p2 = NULL;
  unsigned char *p1;

  unsigned char *lines[288];
  unsigned char *lines_wss[32];
  int xoffset;
  int offset32;
  int secam;
  static int pbUpdateBuffer;
  static int pbViewBuffer;
  static int traitement_OK;

  //printf("xsize = %d, xsize_src = %d, ysize = %d, dest_xsize = %d, YSIZE = %d\n", xsize, xsize_src, ysize, dest_xsize, YSIZE);



  secam = (cur_norm == TVNORM_SECAM);

  xsize_src *= 2; // nb of bytes in YUV line
  //printf ("xsize_src = %d\n", xsize_src);

  xsize *= 2;
  //printf ("xsize = %d\n", xsize);


  xoffset = (xsize_src - xsize) & ~3;
  //printf ("xoffset = %d\n", xoffset);

  //printf ("dest_xsize = %d\n", dest_xsize);


  //********************************************************************
  //                 HALF FRAME YUV HW: NOT NAGRA CODED
  //********************************************************************

  if (!nagra_coded)
    {
      if (ybar_auto)
        ybar = 1;

      if (xoffset == 0)
        {
          p2 =  dest + (ybar * /*dest_xsize*/xsize);
          p1 = src + (ybar * xsize_src);
          fast_memcpy (p2, p1, xsize_src*(ysize-2*ybar));
        }
      else
        {
          p2 =  dest + (ybar * /*dest_xsize*/xsize);
          p1 = src + xoffset + (ybar * xsize_src);
          for (i=0;i<2*(288-ybar);i++)
            {
              fast_memcpy (p2, p1, xsize_src);
              p1 += xsize_src;
              p2 += xsize;
            }
        }
      return;
    }  // if (!nagra_coded)

    

  if(number_couples==4)
  {

  meuhmeuh->Full_Field=0/*!decode_trame_impaire*/;
  meuhmeuh->CurrentFrame=even;
  meuhmeuh->CurrentX=xsize_src/2;
  meuhmeuh->MovieBoost=ybar/2-1;
  
  if (meuhmeuh->MovieBoost<0) meuhmeuh->MovieBoost = 0;
  
  for(i=0;i<288;i++)
{
    meuhmeuh->EvenLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i) * xsize_src] ;
    meuhmeuh->OddLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i+1) * xsize_src];
    
}


  *(meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame])=0;
  *(meuhmeuh->OutOddLines [meuhmeuh->CurrentFrame])=0;


   // Paire
  meuhmeuh->DoStuff(0,&pbUpdateBuffer,&pbViewBuffer);
  
  // impaire
  meuhmeuh->DoStuff(1,&pbUpdateBuffer,&pbViewBuffer);
  traitement_OK = pbUpdateBuffer;

  if (!traitement_OK) return;


p2 = dest + (ybar * xsize);


	for(y = ybar/2; y < (ysize-ybar)/2; y++)
        {
          p1 = (char *) meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame][y];
	        if(p1)
	        {
                 fast_memcpy(p2, p1, xsize_src  );
                 fast_memcpy(p2+xsize_src, p1, xsize_src );
	        }
	        else
	           printf("meuhmeuh->OutEvenLines[0][y]=NULL\n");
	        p2 += 2*xsize_src;

        }

  }
  else
  {


  //********************************************************************
  //                   HALF FRAME YUV HW: NAGRA CODED
  //********************************************************************
  for (i = 0; i < 32; i++)
    lines_wss[i] = linebuf + i * xsize_src;

  // use_wss_line=1;
  if (use_wss_line)                // die WideScreeLine wird verwendet ?
    {
      /* wenn, dann erstes Halbbild dekodieren, da Zeile 23 mit der WSS-Line
       * im ersten Halbbild liegt */

      // die ersten 32 Zeilen wurden bereits im letzten Frame gesendet,
      // deshalb die in 'linebuf' gesicherten Zeilen nehmen, 
      // ein Dreifachbuffer wre aber besser */
      for (i = 0; i < 32; i++)
        lines[i] = linebuf + i * xsize_src;

      for (i = 0; i < 255; i++)
        lines[i + 32] = &src[(2 * i) * xsize_src];
      //Hier??  burst_phase=1-burst_phase;
    }
  else
    {
      /* ansonsten zweites Halbbild */
      for (i = 0; i < 32; i++)
        lines[i] = &src[(2 * (288 - 33 + i)) * xsize_src];

      for (i = 0; i < 255; i++)
        lines[i + 32] = &src[(2 * i + 1) * xsize_src];
    }

  /* dekodieren  */
  decode_nagra (perm, (void **) lines, (void **) lines_wss, xsize_src / 2);

  if (ybar_auto)
    {
      if (bbfrcount > 25*5) // update ybar every 5 secs (assuming there is 25 fps)
        bbfrcount = 0;

      if (bbfrcount < 10) // update only using 10 frames
        {
          Black_Matrix(lines, xsize_src/2);
          ybar = 2*find_ybar(perm, xsize_src/2, 1);
          if (ybar == 0)
            ybar = 1;
          //printf("ybar = %d\n", ybar);
        }
      bbfrcount++;
    }

#ifndef DISABLE_ALL_FILTERS
  if (secam)
    half_blueline_filter(src, lines, perm, xsize_src, ysize);
#endif

  if (use_wss_line)                // die WideScreeLine wird verwendet ?
    {
      burst_phase = 1 - burst_phase;
      // erste Zeile lschen
      for (i = 0; i < xsize_src / 4; i++)
        *(((unsigned int *) lines[perm[0]]) + i) = 0x80008000;    //notwendig?
      // memset(lines[perm[0]],0,xsize*2);
    }

  /* und die Zeilen in der richtigen Reihenfolge nach *dest kopieren, dabei
   * wird auch die Y-Richtung skaliert */
      
  //p2 = dest + (ybar * xsize_src);
  p2 = dest + (ybar * xsize);

  if (secam)
    //********************************************************************
    //                   HALF FRAME YUV HW: SECAM rendering
    //********************************************************************
    {
      for(y = ybar/2; y < (ysize-ybar)/2; y++)
        {
          p1 = lines[perm[y]] + xoffset;
          fast_memcpy(p2, p1, xsize_src);
          fast_memcpy(p2+xsize_src, p1, xsize_src);
          p2 += 2*xsize_src;
        }
    }
  else
    //********************************************************************
    //                   HALF FRAME YUV HW: PAL rendering
    //********************************************************************
    {
      for(y = ybar/2; y < (ysize-ybar)/2; y++)
        {
          offset32 = 0x1a;

          i1 = y & 1;
          if (burst_phase == 0)
            i1 ^= 1;

          i2 = perm[y] & 1;
          if (use_wss_line)
            {
              if (perm[y] < 32)
                i2 ^= 1;
              offset32 = 0x19;
            }
          if (burst_phase == 0)
            i2 ^= 1;

          p1 = lines[perm[y]] + xoffset;
          putline_PAL_YVU (i1, i2, offset32, y, perm[y], xsize, p2, p1);
          putline_PAL_YVU (i1, i2, offset32, i, perm[y], xsize, p2 + /*xsize_src*/xsize, p1);
          p2 += 2*/*xsize_src*/xsize;
        }
    }

  /* save 32 lines for next image */
  for (i = 0; i < 32; i++)
    fast_memcpy (linebuf + i * xsize_src, &src[(511 + i * 2) * xsize_src],
            xsize_src);
  }
}


//********************************************************************
//                      F U L L   F R A M E   R G B
//********************************************************************
void
decode_fullframe_RGB (unsigned char *dest,
                  unsigned char *src, int xsize, int xsize_src, int ysize,
                  int dest_xsize)
{
  int i, y, y1;
  int i1, i2;
  unsigned short perm_e[288];
  unsigned short perm_o[288];
  short *p2;
  unsigned char *p1;
  unsigned char *lines_e[288];
  unsigned char *lines_o[288];
  unsigned char *lines_wss_o[32];
  int count;
  int xoffset;
  int offset32;
  int secam;
  int yd;

  static int pbUpdateBuffer;
  static int pbViewBuffer;
  static int traitement_OK;


  //printf("xsize = %d, xsize_src = %d, ysize = %d, dest_xsize = %d\n", xsize, xsize_src, ysize, dest_xsize);

  secam = (cur_norm == TVNORM_SECAM);

  xsize_src *= 2;
  xsize *= 2;

  if (bpp == 24)
    {
      dest_xsize *= 2;
      putline_pal      = putline_PAL_RGB32;
      putlinedup_pal   = putlinedup_PAL_RGB32;
      putline_secam    = putline_SECAM_RGB32;
      putlinedup_secam = putlinedup_SECAM_RGB32;
    }
  else
    {
      putline_pal      = putline_PAL_RGB16;
      putlinedup_pal   = putlinedup_PAL_RGB16;
      putline_secam    = putline_SECAM_RGB16;
      putlinedup_secam = putlinedup_SECAM_RGB16;
    }

  ysize -= 1;
  xoffset = (xsize_src - xsize) & ~3;

  //********************************************************************
  //                   FULL FRAME RGB: NOT NAGRA CODED
  //********************************************************************
  if (!nagra_coded)
    {
      // it doesn't matter if we use putline_pal or putline_secam as lines are not scrambled
      // putline_secam should just be a little bit faster...
      if (ybar_auto)
        ybar = 1;

      yd = (ybar*ysize)/(YSIZE*2); 
      p2 = (short *) dest + (yd * dest_xsize);
      p1 = src + xoffset + (ybar * xsize_src);
      // resize: make it smaller
      count = YSIZE;
      for (y = ybar; y < ((YSIZE * 2) - ybar); y++)
        {
          count += ysize;
          if (count >= YSIZE * 2)
            {
              // output line
              //putline_pal (0, 0, 0, y, y + 32, xsize, p2, p1);
              putline_secam(xsize, p2, p1);
              count -= YSIZE * 2;
              p2 += dest_xsize;
            }
          p1 += xsize_src;
        }
      return;
    }

    if(number_couples==4)
    {

  meuhmeuh->Full_Field=1/*!decode_trame_impaire*/;
  meuhmeuh->CurrentFrame=even;
  meuhmeuh->CurrentX=xsize_src/2;
  meuhmeuh->MovieBoost=ybar/2-1;

  if (meuhmeuh->MovieBoost<0) meuhmeuh->MovieBoost = 0;

  for(i=0;i<288;i++)
{
    meuhmeuh->EvenLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i) * xsize_src] ;
    meuhmeuh->OddLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i+1) * xsize_src];

}

  *(meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame])=0;
  *(meuhmeuh->OutOddLines [meuhmeuh->CurrentFrame])=0;

  // Paire
  meuhmeuh->DoStuff(0,&pbUpdateBuffer,&pbViewBuffer);
  traitement_OK = pbUpdateBuffer;

  // impaire
  meuhmeuh->DoStuff(1,&pbUpdateBuffer,&pbViewBuffer);

  traitement_OK = traitement_OK && pbUpdateBuffer;

  if(!traitement_OK) return;

  yd = (ybar*ysize)/(YSIZE*2);
  p2 = (short *) dest + (yd * dest_xsize);

  // only making it smaller has sense
      count = YSIZE;
      for (y = ybar; y < (YSIZE * 2)-ybar; y++)
        {
          y1 = y / 2;
          count += ysize;
          if (count >= (YSIZE * 2))
            {
              // output line
              if (y & 1)
                {
                  // line in second half frame
                  p1 = (char*)meuhmeuh->OutOddLines [meuhmeuh->CurrentFrame][y1] + xoffset;
                  putline_secam (xsize, p2, p1);

                }
              else
                {
                      p1 = (char*)meuhmeuh->OutEvenLines [meuhmeuh->CurrentFrame][y1] + xoffset;
                      putline_secam (xsize, p2, p1);                   
                }
              count -= (YSIZE * 2);
              p2 += dest_xsize;
            }
          else
            {
              // discard line
              p1 += xsize;
            }
        }


  }
  else
  {

  //********************************************************************
  //                   FULL FRAME RGB: NAGRA CODED
  //********************************************************************

  for (i = 0; i < 32; i++)
    lines_wss_o[i] = linebuf_o + i * xsize_src;

  if (use_wss_line)                // die WideScreeLine wird verwendet ?
    {
      /* wenn, dann erstes Halbbild dekodieren, da Zeile 23 mit der WSS-Line
       * im ersten Halbbild liegt */

      // die ersten 32 Zeilen wurden bereits im letzten Frame gesendet,
      // deshalb die in 'linebuf' gesicherten Zeilen nehmen,
      // ein Dreifachbuffer wre aber besser */
      for (i = 0; i < 32; i++)
        lines_o[i] = linebuf_o + i * xsize_src;

      for (i = 0; i < 255; i++)
        lines_o[i + 32] = &src[(2 * i) * xsize_src];
    }
  else
    {
      /* ansonsten zweites Halbbild */
      for (i = 0; i < 32; i++)
        lines_o[i] = &src[(2 * (288 - 33 + i)) * xsize_src];

      for (i = 0; i < 255; i++)
        lines_o[i + 32] = &src[(2 * i + 1) * xsize_src];
    }
  burst_phase = 1 - burst_phase;

  /* find permutation for second halfburst_phase */
  //    decode_nagra (perm_o, (void **) lines_o, (void**)lines_wss_o, xsize_src);
  decode_nagra (perm_o, (void **) lines_o, NULL, xsize_src / 2);

  if (use_wss_line)                // die WideScreeLine wird verwendet ?
    {
      burst_phase = 1 - burst_phase;
    }

  burst_phase_orig = burst_phase;
  /* find permutation for first halfburst_phase */

  // Unfug, diese Zeilen gehren zum zweiten Halbbild
  for (i = 0; i < 32; i++)
    lines_e[i] = &src[(2 * (288 - 33 + i)) * xsize_src];

  for (i = 0; i < 255; i++)
    lines_e[i + 32] = &src[(2 * i) * xsize_src];

  decode_nagra (perm_e, (void **) lines_e, (void **) lines_wss_o,
                xsize_src / 2);

  if (ybar_auto)
    {
      if (bbfrcount > 25*5) // update ybar every 5 secs (assuming there is 25 fps)
        bbfrcount = 0;

      if (bbfrcount < 10) // update only using 10 frames
        {
          Black_Matrix(lines_e, xsize_src/2);
          ybar = find_ybar(perm_e, xsize_src/2, 1);
          //Black_Matrix(lines_o, xsize_src/2);
          //ybar += find_ybar(perm_o, xsize_src/2, 0);
          ybar *= 2;
          if (ybar == 0)
            ybar = 1;
        }
      bbfrcount++;
    }

#ifndef DISABLE_ALL_FILTERS
  if (secam)
    full_blueline_filter(src, lines_e, lines_o, perm_e, perm_o, xsize_src, ysize);
#endif

  // for (i = 0; i < 288; i++) perm_e[i] = i;

  /* do the permutation */
  yd = (ybar*ysize)/(YSIZE*2); 
  p2 = (short *) dest + (yd * dest_xsize);



  if (secam)
  //********************************************************************
  //                  FULL FRAME RGB: SECAM rendering
  //********************************************************************
    {
      // only making it smaller has sense
      count = YSIZE;
      for (y = ybar; y < (YSIZE * 2)-ybar; y++)
        {
          y1 = y / 2;
          count += ysize;
          if (count >= (YSIZE * 2))
            { 
              // output line
              if (y & 1)
                {
                  // line in second half frame
                  p1 = lines_o[perm_o[y1]] + xoffset;
                  putline_secam (xsize, p2, p1);

                }
              else
                {
                  // line in first half frame
                  if (perm_e[y1] < 33)
                    {
                      // line is not availabe
                      // therefore ouput matching line
                      // from second half frame

                      p1 = lines_o[perm_o[y1]] + xoffset;
                      putline_secam (xsize, p2, p1);
                    }
                  else
                    {
                      p1 = lines_e[perm_e[y1]] + xoffset;
                      putline_secam (xsize, p2, p1);
                    }
                }
              count -= (YSIZE * 2);
              p2 += dest_xsize;
            }
          else
            {
              // discard line
              p1 += xsize;
            }
        }
    }
  else //(if secam)
  //********************************************************************
  //                  FULL FRAME RGB: PAL rendering
  //********************************************************************
    {
      // only making it smaller has sense
      count = YSIZE;
      for (y = ybar; y < (YSIZE * 2)-ybar; y++)
        {
          y1 = y / 2;
          count += ysize;
          if (count >= (YSIZE * 2))
            {
              // output line
              if (y & 1)
                {
                  // line in second half frame
                  p1 = lines_o[perm_o[y1]] + xoffset;
                  offset32 = 0x1a;
                  i1 = y1 & 1;
                  if (burst_phase_orig == 0)
                    i1 ^= 1;
                  i2 = perm_o[y1] & 1;
                  if (use_wss_line)
                    {
                      if (perm_o[y1] < 32)
                        i2 ^= 1;
                      offset32 = 0x19;
                    }

                  if (burst_phase_orig == 0)
                    i2 ^= 1;
                  putline_pal (i1, i2, offset32, y1, perm_o[y1], xsize, p2, p1);

                }
              else
                {
                  // line in first half frame
                  if (perm_e[y1] < 33)
                    {
                      // line is not availabe
                      // therefore ouput matching line
                      // from second half frame

                      p1 = lines_o[perm_o[y1]] + xoffset;
                      offset32 = 0x1a;
                      i1 = y1 & 1;
                      if (burst_phase_orig == 0)
                        i1 ^= 1;
                      i2 = perm_o[y1] & 1;
                      if (use_wss_line)
                        {
                          if (perm_o[y1] < 32)
                            i2 ^= 1;
                          offset32 = 0x19;
                        }

                      if (burst_phase_orig == 0)
                        i2 ^= 1;

                      putline_pal (i1, i2, offset32, y1, perm_o[y1], xsize, p2, p1);
                    }
                  else
                    {
                      p1 = lines_e[perm_e[y1]] + xoffset;
                      offset32 = 0x19;
                      i1 = y1 & 1;
                      if (burst_phase == 1)
                        i1 ^= 1;
                      i2 = perm_e[y1] & 1;
                      if (burst_phase == 1)
                        i2 ^= 1;
                      putline_pal (i1, i2, offset32, y1, perm_e[y1], xsize, p2, p1);
                    }
                }
              count -= (YSIZE * 2);
              p2 += dest_xsize;
            }
          else
            {
              // discard line
              p1 += xsize;
            }
        }
    }

  /* save 32 lines for next image */
  for (i = 0; i < 32; i++)
    fast_memcpy (linebuf_o + i * xsize_src, &src[(511 + i * 2) * xsize_src],
            xsize_src);
 }           

}

//********************************************************************
//                  F U L L   F R A M E   Y U V   S W
//********************************************************************
void
decode_fullframe_YUV_sw (unsigned char *dest,
                  unsigned char *src, int xsize, int xsize_src, int ysize,
                  int dest_xsize)
{
  int i, y, y1;
  int i1, i2;
  unsigned short perm_e[288];
  unsigned short perm_o[288];
  short *p2;
  unsigned char *p1;
  unsigned char *lines_e[288];
  unsigned char *lines_o[288];
  unsigned char *lines_wss_o[32];
  int count;
  int xoffset;
  int offset32;
  int secam;
  int yd;

  static int pbUpdateBuffer;
  static int pbViewBuffer;
  static int traitement_OK;


  //printf("xsize = %d, xsize_src = %d, ysize = %d, dest_xsize = %d\n", xsize, xsize_src, ysize, dest_xsize);

  secam = (cur_norm == TVNORM_SECAM);

  xsize_src *= 2;
  xsize *= 2;

  ysize -= 1;
  xoffset = (xsize_src - xsize) & ~3;

  //********************************************************************
  //                  FULL FRAME YUV SW: NOT NAGRA CODED
  //********************************************************************
  if (!nagra_coded)
    {
      if (ybar_auto)
        ybar = 1;

      yd = (ybar*ysize)/(YSIZE*2); 
      p2 = (short *) dest + (yd * dest_xsize);
      p1 = src + xoffset + (ybar * xsize_src);
      // resize: make it smaller
      count = YSIZE;
      for (y = ybar; y < ((YSIZE * 2) - ybar); y++)
        {
          count += ysize;
          if (count >= YSIZE * 2)
            {
              // output line
              //putline_pal (0, 0, 0, y, y + 32, xsize, p2, p1);
              //putline_secam (xsize, p2, p1);
              fast_memcpy(p2, p1, xsize);
              count -= YSIZE * 2;
              p2 += dest_xsize;
            }
          p1 += xsize_src;
        }
      return;
    }



     if(number_couples==4)
    {

  meuhmeuh->Full_Field=1/*!decode_trame_impaire*/;
  meuhmeuh->CurrentFrame=even;
  meuhmeuh->CurrentX=xsize_src/2;
  meuhmeuh->MovieBoost=ybar/2-1;

  if (meuhmeuh->MovieBoost<0) meuhmeuh->MovieBoost = 0;

  for(i=0;i<288;i++)
{
    meuhmeuh->EvenLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i) * xsize_src] ;
    meuhmeuh->OddLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i+1) * xsize_src];

}

  *(meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame])=0;
  *(meuhmeuh->OutOddLines [meuhmeuh->CurrentFrame])=0;

  // Paire
  meuhmeuh->DoStuff(0,&pbUpdateBuffer,&pbViewBuffer);
  traitement_OK = pbUpdateBuffer;

  // impaire
  meuhmeuh->DoStuff(1,&pbUpdateBuffer,&pbViewBuffer);

  traitement_OK = traitement_OK && pbUpdateBuffer;

  if( !traitement_OK) return;

  yd = (ybar*ysize)/(YSIZE*2);
  p2 = (short *) dest + (yd * dest_xsize);

  // only making it smaller has sense
      count = YSIZE;
      for (y = ybar; y < (YSIZE * 2)-ybar; y++)
        {
          y1 = y / 2;
          count += ysize;
          if (count >= (YSIZE * 2))
            {
              // output line
              if (y & 1)
                {
                  // line in second half frame
                  p1 = (char *)meuhmeuh->OutOddLines [meuhmeuh->CurrentFrame][y1] + xoffset;
                  //putline_secam (xsize, p2, p1);
                  fast_memcpy(p2, p1, xsize);

                }
              else
                {
                  // line in first half frame
                  
                      p1 = (char *)meuhmeuh->OutEvenLines [meuhmeuh->CurrentFrame][y1] + xoffset;
                      //putline_secam (xsize, p2, p1);
                      fast_memcpy(p2, p1, xsize);
                    
                }
              count -= (YSIZE * 2);
              p2 += dest_xsize;
            }
          else
            {
              // discard line
              p1 += xsize;
            }
        }

  }
  else
  {

  //********************************************************************
  //                   FULL FRAME YUV SW: NAGRA CODED
  //********************************************************************

  for (i = 0; i < 32; i++)
    lines_wss_o[i] = linebuf_o + i * xsize_src;

  if (use_wss_line)                // die WideScreeLine wird verwendet ?
    {
      /* wenn, dann erstes Halbbild dekodieren, da Zeile 23 mit der WSS-Line
       * im ersten Halbbild liegt */

      // die ersten 32 Zeilen wurden bereits im letzten Frame gesendet,
      // deshalb die in 'linebuf' gesicherten Zeilen nehmen,
      // ein Dreifachbuffer wre aber besser */
      for (i = 0; i < 32; i++)
        lines_o[i] = linebuf_o + i * xsize_src;

      for (i = 0; i < 255; i++)
        lines_o[i + 32] = &src[(2 * i) * xsize_src];
    }
  else
    {
      /* ansonsten zweites Halbbild */
      for (i = 0; i < 32; i++)
        lines_o[i] = &src[(2 * (288 - 33 + i)) * xsize_src];

      for (i = 0; i < 255; i++)
        lines_o[i + 32] = &src[(2 * i + 1) * xsize_src];
    }
  burst_phase = 1 - burst_phase;

  /* find permutation for second halfburst_phase */
  //    decode_nagra (perm_o, (void **) lines_o, (void**)lines_wss_o, xsize_src);
  decode_nagra (perm_o, (void **) lines_o, NULL, xsize_src / 2);

  if (use_wss_line)                // die WideScreeLine wird verwendet ?
    {
      burst_phase = 1 - burst_phase;
    }

  burst_phase_orig = burst_phase;
  /* find permutation for first halfburst_phase */

  // Unfug, diese Zeilen gehren zum zweiten Halbbild
  for (i = 0; i < 32; i++)
    lines_e[i] = &src[(2 * (288 - 33 + i)) * xsize_src];

  for (i = 0; i < 255; i++)
    lines_e[i + 32] = &src[(2 * i) * xsize_src];

  decode_nagra (perm_e, (void **) lines_e, (void **) lines_wss_o,
                xsize_src / 2);

  if (ybar_auto)
    {
      if (bbfrcount > 25*5) // update ybar every 5 secs (assuming there is 25 fps)
        bbfrcount = 0;

      if (bbfrcount < 10) // update only using 10 frames
        {
          Black_Matrix(lines_e, xsize_src/2);
          ybar = find_ybar(perm_e, xsize_src/2, 1);
          //Black_Matrix(lines_o, xsize_src/2);
          //ybar += find_ybar(perm_o, xsize_src/2, 0);
          ybar *= 2;
          if (ybar == 0)
            ybar = 1;
        }
      bbfrcount++;
    }

#ifndef DISABLE_ALL_FILTERS
  if (secam)
    full_blueline_filter(src, lines_e, lines_o, perm_e, perm_o, xsize_src, ysize);
#endif

  // for (i = 0; i < 288; i++) perm_e[i] = i;

  /* do the permutation */
  yd = (ybar*ysize)/(YSIZE*2); 
  p2 = (short *) dest + (yd * dest_xsize);



  if (secam)
  //********************************************************************
  //                  FULL FRAME YUV SW: SECAM rendering
  //********************************************************************
    {
      // only making it smaller has sense
      count = YSIZE;
      for (y = ybar; y < (YSIZE * 2)-ybar; y++)
        {
          y1 = y / 2;
          count += ysize;
          if (count >= (YSIZE * 2))
            { 
              // output line
              if (y & 1)
                {
                  // line in second half frame
                  p1 = lines_o[perm_o[y1]] + xoffset;
                  //putline_secam (xsize, p2, p1);
                  fast_memcpy(p2, p1, xsize);

                }
              else
                {
                  // line in first half frame
                  if (perm_e[y1] < 33)
                    {
                      // line is not availabe
                      // therefore ouput matching line
                      // from second half frame

                      p1 = lines_o[perm_o[y1]] + xoffset;
                      //putline_secam (xsize, p2, p1);
                      fast_memcpy(p2, p1, xsize);
                    }
                  else
                    {
                      p1 = lines_e[perm_e[y1]] + xoffset;
                      //putline_secam (xsize, p2, p1);
                      fast_memcpy(p2, p1, xsize);
                    }
                }
              count -= (YSIZE * 2);
              p2 += dest_xsize;
            }
          else
            {
              // discard line
              p1 += xsize;
            }
        }
    }
  else //(if secam)
  //********************************************************************
  //                  FULL FRAME YUV SW: PAL rendering
  //********************************************************************
    {
      // only making it smaller has sense
      count = YSIZE;
      for (y = ybar; y < (YSIZE * 2)-ybar; y++)
        {
          y1 = y / 2;
          count += ysize;
          if (count >= (YSIZE * 2))
            {
              // output line
              if (y & 1)
                {
                  // line in second half frame
                  p1 = lines_o[perm_o[y1]] + xoffset;
                  offset32 = 0x1a;
                  i1 = y1 & 1;
                  if (burst_phase_orig == 0)
                    i1 ^= 1;
                  i2 = perm_o[y1] & 1;
                  if (use_wss_line)
                    {
                      if (perm_o[y1] < 32)
                        i2 ^= 1;
                      offset32 = 0x19;
                    }

                  if (burst_phase_orig == 0)
                    i2 ^= 1;
                  //putline_pal (i1, i2, offset32, y1, perm_o[y1], xsize, p2, p1);
                  putline_PAL_YVU (i1, i2, offset32, y1, perm_o[y1], xsize, p2, p1);

                }
              else
                {
                  // line in first half frame
                  if (perm_e[y1] < 33)
                    {
                      // line is not availabe
                      // therefore ouput matching line
                      // from second half frame

                      p1 = lines_o[perm_o[y1]] + xoffset;
                      offset32 = 0x1a;
                      i1 = y1 & 1;
                      if (burst_phase_orig == 0)
                        i1 ^= 1;
                      i2 = perm_o[y1] & 1;
                      if (use_wss_line)
                        {
                          if (perm_o[y1] < 32)
                            i2 ^= 1;
                          offset32 = 0x19;
                        }

                      if (burst_phase_orig == 0)
                        i2 ^= 1;

                      //putline_pal (i1, i2, offset32, y1, perm_o[y1], xsize, p2, p1);
                      putline_PAL_YVU (i1, i2, offset32, y1, perm_o[y1], xsize, p2, p1);
                    }
                  else
                    {
                      p1 = lines_e[perm_e[y1]] + xoffset;
                      offset32 = 0x19;
                      i1 = y1 & 1;
                      if (burst_phase == 1)
                        i1 ^= 1;
                      i2 = perm_e[y1] & 1;
                      if (burst_phase == 1)
                        i2 ^= 1;
                      //putline_pal (i1, i2, offset32, y1, perm_e[y1], xsize, p2, p1);
                      putline_PAL_YVU (i1, i2, offset32, y1, perm_e[y1], xsize, p2, p1);
                    }
                }
              count -= (YSIZE * 2);
              p2 += dest_xsize;
            }
          else
            {
              // discard line
              p1 += xsize;
            }
        }
    }

  /* save 32 lines for next image */
  for (i = 0; i < 32; i++)
    fast_memcpy (linebuf_o + i * xsize_src, &src[(511 + i * 2) * xsize_src],
            xsize_src);
  }  

}



//********************************************************************
//                  F U L L   F R A M E   Y U V   H W
//********************************************************************
void
decode_fullframe_YUV_hw (unsigned char *dest,
                  unsigned char *src, int xsize, int xsize_src, int ysize,
                  int dest_xsize)
{
  int i, y, y1;
  int i1, i2;
  unsigned short perm_e[288];
  unsigned short perm_o[288];
  unsigned char *p2;
  unsigned char *p1;
  unsigned char *lines_e[288];
  unsigned char *lines_o[288];
  unsigned char *lines_wss_o[32];
  int xoffset;
  int offset32;
  int secam;
  static int traitement_OK;


  static int pbUpdateBuffer,pbViewBuffer;

  //printf("xsize = %d, xsize_src = %d, ysize = %d, dest_xsize = %d\n", xsize, xsize_src, ysize, dest_xsize);

  secam = (cur_norm == TVNORM_SECAM);

  xsize_src *= 2;
  xsize *= 2;

  ysize -= 1;
  xoffset = (xsize_src - xsize) & ~3;

  //********************************************************************
  //                 FULL FRAME YUV HW: NOT NAGRA CODED
  //********************************************************************
  if (!nagra_coded)
    {
      if (ybar_auto)
        ybar = 1;

      if (xoffset == 0)
        {
          p2 = dest + (ybar * /*dest_xsize*/xsize);
          p1 = src + (ybar * xsize_src);
          fast_memcpy (p2, p1, xsize_src*(ysize-2*ybar));
        }
      else
        {
          p2 =  dest + (ybar * /*dest_xsize*/xsize);
          p1 = src + xoffset + (ybar * xsize_src);
          for (i=0;i<2*(288-ybar);i++)
            {
              fast_memcpy (p2, p1, xsize_src);
              p1 += xsize_src;
              p2 += xsize;
            }
        }
      return;
    } // if (!nagra_coded)

    if(number_couples==4)
    {

  meuhmeuh->Full_Field=1/*!decode_trame_impaire*/;
  meuhmeuh->CurrentFrame=even;
  meuhmeuh->CurrentX=xsize_src/2;
  meuhmeuh->MovieBoost=ybar/2-1;

  if (meuhmeuh->MovieBoost<0) meuhmeuh->MovieBoost = 0;

  for(i=0;i<288;i++)
{
    meuhmeuh->EvenLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i) * xsize_src] ;
    meuhmeuh->OddLines [meuhmeuh->CurrentFrame][i] = (short *)&src[(2 * i+1) * xsize_src];

}

  *(meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame])=0;
  *(meuhmeuh->OutOddLines [meuhmeuh->CurrentFrame])=0;

  // Paire
  meuhmeuh->DoStuff(0,&pbUpdateBuffer,&pbViewBuffer);
  traitement_OK = pbUpdateBuffer;

  // impaire
  meuhmeuh->DoStuff(1,&pbUpdateBuffer,&pbViewBuffer);

  traitement_OK = traitement_OK && pbUpdateBuffer;

  if( !traitement_OK) return;
 


p2 = dest + (ybar * xsize);


	for(y = ybar/2; y < (ysize-ybar)/2; y++)
        {
          p1 = (char *) meuhmeuh->OutEvenLines[meuhmeuh->CurrentFrame][y];
	        if(p1)
            fast_memcpy(p2, p1, xsize_src  );

	        else
	           printf("meuhmeuh->OutEvenLines[0][y]=NULL\n");

           p1 = (char *) meuhmeuh->OutOddLines[meuhmeuh->CurrentFrame][y];
	        if(p1)
	            fast_memcpy(p2+xsize_src, p1, xsize_src );
	        else
	           printf("meuhmeuh->OutOddLines[0][y]=NULL\n");      
	        p2 += 2*xsize_src;

        }

     }
     else
     {   

        
  //********************************************************************
  //                   FULL FRAME YUV HW: NAGRA CODED
  //********************************************************************
  for (i = 0; i < 32; i++)
    lines_wss_o[i] = linebuf_o + i * xsize_src;

  if (use_wss_line)                // die WideScreeLine wird verwendet ?
    {
      /* wenn, dann erstes Halbbild dekodieren, da Zeile 23 mit der WSS-Line
       * im ersten Halbbild liegt */

      // die ersten 32 Zeilen wurden bereits im letzten Frame gesendet,
      // deshalb die in 'linebuf' gesicherten Zeilen nehmen,
      // ein Dreifachbuffer wre aber besser */
      for (i = 0; i < 32; i++)
        lines_o[i] = linebuf_o + i * xsize_src;

      for (i = 0; i < 255; i++)
        lines_o[i + 32] = &src[(2 * i) * xsize_src];
    }
  else
    {
      /* ansonsten zweites Halbbild */
      for (i = 0; i < 32; i++)
        lines_o[i] = &src[(2 * (288 - 33 + i)) * xsize_src];

      for (i = 0; i < 255; i++)
        lines_o[i + 32] = &src[(2 * i + 1) * xsize_src];
    }
  burst_phase = 1 - burst_phase;

  /* find permutation for second halfburst_phase */
  //    decode_nagra (perm_o, (void **) lines_o, (void**)lines_wss_o, xsize_src);
  decode_nagra (perm_o, (void **) lines_o, NULL, xsize_src / 2);

  if (use_wss_line)                // die WideScreeLine wird verwendet ?
    {
      burst_phase = 1 - burst_phase;
    }

  burst_phase_orig = burst_phase;
  /* find permutation for first halfburst_phase */

  // Unfug, diese Zeilen gehren zum zweiten Halbbild
  for (i = 0; i < 32; i++)
    lines_e[i] = &src[(2 * (288 - 33 + i)) * xsize_src];

  for (i = 0; i < 255; i++)
    lines_e[i + 32] = &src[(2 * i) * xsize_src];

  decode_nagra (perm_e, (void **) lines_e, (void **) lines_wss_o,
                xsize_src / 2);

  if (ybar_auto)
    {
      if (bbfrcount > 25*5) // update ybar every 5 secs (assuming there is 25 fps)
        bbfrcount = 0;

      if (bbfrcount < 10) // update only using 10 frames
        {
          Black_Matrix(lines_e, xsize_src/2);
          ybar = find_ybar(perm_e, xsize_src/2, 1);
          //Black_Matrix(lines_o, xsize_src/2);
          //ybar += find_ybar(perm_o, xsize_src/2, 0);
          ybar *= 2;
          if (ybar == 0)
            ybar = 1;
          //printf("ybar = %d\n", ybar);
        }
      bbfrcount++;
    }

#ifndef DISABLE_ALL_FILTERS
  if (secam)
    full_blueline_filter(src, lines_e, lines_o, perm_e, perm_o, xsize_src, ysize);
#endif

  // for (i = 0; i < 288; i++) perm_e[i] = i;

  /* do the permutation */
  //p2 =  dest + (ybar * xsize_src);
  p2 =  dest + (ybar * xsize);

  if (secam)
    //********************************************************************
    //                   FULL FRAME YUV HW: SECAM rendering
    //********************************************************************
    {
      for (y=ybar; y<(ysize-ybar);y++)
        {
          y1 = y/2;
          if (y&1)
            {
              p1 = lines_o[perm_o[y1]] + xoffset;
              fast_memcpy (p2, p1, xsize);
            }
          else
            {
              if (perm_e[y1] < 33)
                p1 = lines_o[perm_o[y1]] + xoffset;
              else
                p1 = lines_e[perm_e[y1]] + xoffset;
              
              fast_memcpy (p2+xsize_src, p1, xsize);
              p2 += 2 * xsize_src;
            }
        }
    }
  else
    //********************************************************************
    //                    FULL FRAME YUV HW: PAL rendering
    //********************************************************************
    {
      for (y=ybar; y<(ysize-ybar);y++)
        {
          y1 = y/2;
          if (y&1)
            {
              // Line in second half frame
              p1 = lines_o[perm_o[y1]] + xoffset;
              offset32 = 0x1a;
              i1 = y1 & 1;
              if (burst_phase_orig == 0)
                i1 ^= 1;
              i2 = perm_o[y1] & 1;
              if (use_wss_line)
                {
                  if (perm_o[y1] < 32)
                    i2 ^= 1;
                  offset32 = 0x19;
                }
              
              if (burst_phase_orig == 0)
                i2 ^= 1;

              putline_PAL_YVU (i1, i2, offset32, y1, perm_o[y1], xsize, p2, p1);
            }
          else
            {
              // Line in first half frame
              if (perm_e[y1] < 33)
                {
                  // line is not availabe
                  // therefore ouput matching line
                  // from second half frame
                  p1 = lines_o[perm_o[y1]] + xoffset;
                  offset32 = 0x1a;
                  i1 = y1 & 1;
                  if (burst_phase_orig == 0)
                    i1 ^= 1;
                  i2 = perm_o[y1] & 1;
                  if (use_wss_line)
                    {
                      if (perm_o[y1] < 32)
                        i2 ^= 1;
                      offset32 = 0x19;
                    }

                  if (burst_phase_orig == 0)
                    i2 ^= 1;

                  putline_PAL_YVU (i1, i2, offset32, y1, perm_o[y1], xsize, p2+xsize, p1);
                }
              else
                {
                  p1 = lines_e[perm_e[y1]] + xoffset;
                  offset32 = 0x19;
                  i1 = y1 & 1;
                  if (burst_phase == 1)
                    i1 ^= 1;
                  i2 = perm_e[y1] & 1;
                  if (burst_phase == 1)
                    i2 ^= 1;

                  putline_PAL_YVU (i1, i2, offset32, y1, perm_e[y1], xsize, p2+xsize, p1);
                }
              p2 += 2 * /*xsize_src*/ xsize;
            }
        }
    }

  /* save 32 lines for next image */
  for (i = 0; i < 32; i++)
    fast_memcpy (linebuf_o + i * xsize_src, &src[(511 + i * 2) * xsize_src],
                 xsize_src);
 }                
}

/* compute the permutation generated by the 15 bit key 'key' */
static void
gen_perm (unsigned short *perm, int key)
{
  int key_start, key_inc, key_index, i, b;
  int buffer[32];

  key_start = key >> 7;
  key_inc = (key & 0x7f) * 2 + 1;

  for (i = 0; i < 32; i++)
    buffer[i] = i;

  key_index = key_start;
  for (i = 0; i < 255; i++)
    {
      b = table_keys[key_index];
      perm[i] = buffer[b];
      buffer[b] = i + 32;

      key_index = (key_index + key_inc) & 0xff;
    }

  for (i = 0; i < 32; i++)
    {
      perm[255 + i] = buffer[i];
    }    
}

void
init_decode (void)
{
  FILE *file;
  char name[128];
  int i;
  double f;
  double f1 = -1.56071095712045105;
  double f2 = 0.1047197551196597746;
  double f3 = 0.7058823529411764706;

  short *p;

  if (meuhmeuh==NULL)
  {
     meuhmeuh=init_mm_Plugin(user_dir);
     if (meuhmeuh)
      { if ( gb_buffers.frames>=3 ) meuhmeuh->NbBuff = 3;
        else meuhmeuh->NbBuff = 2;
      }
  }
  if (number_couples!=4)
  {
  printf ("Reading tables for %i couples\n", number_couples);
  fflush (stdout);

  sprintf (name, "%s/couples%i", user_dir, number_couples);
  if (!(file = fopen (name, "r")))
    {
      printf ("File %s not found\n", name);
      exit (1);
    }
  couple_index_nb =
    fread (couple_index, sizeof (int), sizeof (couple_index) / sizeof (int),
           file);
  fclose (file);

  sprintf (name, "%s/keyline%i", user_dir, number_couples);
  if (!(file = fopen (name, "r")))
    {
      printf ("File %s not found\n", name);
      exit (1);
    }
  fread (key_lines, sizeof (short), number_couples * NB_KEYS, file);
  fclose (file);
  } 
  else
   printf ("Activate MeuhMeuh decode\n");

  p = colortable;

  for (i = 0; i < 1380; i++)
    {
      f = (double) ((i >> 2) - 344) * f1 - f2;
      *p = cos (f) * 8192.0;
      *(p + 2) = sin (f) * 8192.0 * f3;
      *(p + 1) = -sin (f) * 8192.0;
      *(p + 3) = cos (f) * 8192.0 * f3;
      if (i & 2)
        {
          *(p + 2) = -*(p + 2);
          *(p + 3) = -*(p + 3);
        }
      if (i & 1)
        {
          *(p + 1) = -*(p + 1);
          *(p + 3) = -*(p + 3);
        }
      p += 4;
    }

}

/*
 * C version of try_perm
 */

unsigned short *
try_perm (void)
{
  int corr_min;
  unsigned short *key_end, *key_min;
  register unsigned short *key_ptr;
  register int corr;
  int n = 0;

  corr_min = 0x7fffffff;
  key_min = NULL;
  key_ptr = (unsigned short *) key_lines;
  key_end = key_ptr + NB_KEYS * number_couples;

  /* fast correlation on a few lines */
  do
    {
      corr = 0;
      {
        int j;
        for (j = 0; j < number_couples; j += 4)
          {
            corr +=
              *(unsigned int *) ((unsigned char *) correl_lines + key_ptr[j]);
            corr +=
              *(unsigned int *) ((unsigned char *) correl_lines +
                                 key_ptr[j + 1]);
            corr +=
              *(unsigned int *) ((unsigned char *) correl_lines +
                                 key_ptr[j + 2]);
            corr +=
              *(unsigned int *) ((unsigned char *) correl_lines +
                                 key_ptr[j + 3]);
            if (corr > corr_min)
              break;
          }
      }

      /* test correlation */
      if (corr < corr_min)
        {
          corr_min = corr;
          key_min = key_ptr;
        }
      n++;
      key_ptr += number_couples;
    }
  while (key_ptr < key_end);

  return key_min;
}

unsigned short *
try_perm_useStatus (void)
{
  int corr_min;
  unsigned short *key_end, *key_min;
  register unsigned short *key_ptr;
  register int corr = 0;
  int n = 0;

  corr_min = 0x7fffffff;
  key_min = NULL;
  key_ptr = (unsigned short *) key_lines;
  key_end = key_ptr + NB_KEYS * number_couples;

  /* fast correlation on a few lines */
  do
    {

      if (table_keys[n >> 7] == status_line)
        {
          corr = 0;
          {
            int j;
            for (j = 0; j < number_couples; j += 4)
              {
                corr +=
                  *(unsigned int *) ((unsigned char *) correl_lines +
                                     key_ptr[j]);
                corr +=
                  *(unsigned int *) ((unsigned char *) correl_lines +
                                     key_ptr[j + 1]);
                corr +=
                  *(unsigned int *) ((unsigned char *) correl_lines +
                                     key_ptr[j + 2]);
                corr +=
                  *(unsigned int *) ((unsigned char *) correl_lines +
                                     key_ptr[j + 3]);
                if (corr > corr_min)
                  break;
              }
          }


          /* test correlation */
          if (corr < corr_min)
            {
              corr_min = corr;
              key_min = key_ptr;
            }
          n++;
          key_ptr += number_couples;
        }
      else
        {
          n += 128;
          key_ptr += number_couples * 128;
        }
    }
  while (key_ptr < key_end);

  return key_min;
}

int
decode_nagra (unsigned short *perm, void **lines, void **lines_wss, int xsize)
{
  int i, j;
  unsigned short pts_buffer[YSIZE][CX_COUNT], *p;
  int key;
  unsigned short *key_ptr;
  int cx_inc, cx_start;

  cx_inc = xsize / CX_COUNT;
  cx_start = (cx_inc / 2) & 0x7e;
  p = &pts_buffer[0][0];


  use_wss_line = 0;

  /* suche WSS-Line */
  if (lines_wss != NULL)
    {
      int i;
      int dd = 0;
#ifdef DEBUG
      printf ("Check: \n");
#endif
      for (i = 0; i < 32; i++)
        {
#define CHECK_WSS_OFFSET(x) \
                        (int)((float)x * xsize / 830)

#define CHECK_WSS(x) \
                        ((*( ( (unsigned char **) lines_wss )[i] + CHECK_WSS_OFFSET(x) * 2) & 0xf0) >> 4)
#ifdef DEBUG
          for (j = 0; j < xsize; j++)
            {
              if (((*(((unsigned char **) lines_wss)[i] + j * 2) & 0xf0) >> 4)
                  > 0xa)
                {
                  printf ("+");
                }
              else
                if (
                    ((*(((unsigned char **) lines_wss)[i] + j * 2) & 0xf0) >>
                     4) < 0x3)
                {
                  printf ("-");
                }
              else
                {
                  printf ("o");
                }
            }
          printf ("\n");

          printf ("OF: %i,", CHECK_WSS_OFFSET (61));
          printf ("%i,", CHECK_WSS_OFFSET (71));
          printf ("%i,", CHECK_WSS_OFFSET (82));
          printf ("%i,", CHECK_WSS_OFFSET (91));
          printf ("%i", CHECK_WSS_OFFSET (100));
          printf ("->%i ", xsize);

          printf ("VA: %i,", CHECK_WSS (61));
          printf ("%i,", CHECK_WSS (71));
          printf ("%i,", CHECK_WSS (82));
          printf ("%i,", CHECK_WSS (91));
          printf ("%i", CHECK_WSS (100));
#endif
          if ((CHECK_WSS (61) < 4) &&
              (CHECK_WSS (71) > 9) &&
              (CHECK_WSS (82) < 4) &&
              (CHECK_WSS (91) > 9) && (CHECK_WSS (100) < 4))
            {
              status_line = i;
              dd++;
#ifdef DEBUG
              printf (" -> WSS");
#endif
            }
#ifdef DEBUG
          printf ("\n");
#endif
#undef CHECK_WSS_OFFSET
#undef CHECK_WSS
#undef DEBUG
        }
      if (dd == 1)
        {
          use_wss_line = 1;
        }

      //      if (highquality) use_wss_line=0;
    }
  if (force_not_use_wss_line)
    use_wss_line = 0;
#if 0
  if (use_wss_line)
    {
      if (number_couples == NB_COUPLES)
        {
          number_couples = NB_COUPLES_WSS;
          init_decode ();
        }
    }
  else
    {
      if (number_couples == NB_COUPLES_WSS)
        {
          number_couples = NB_COUPLES;
          init_decode ();
        }
    }
#endif
  {                                // phase das pal-burst
    int p = *(((unsigned char **) lines)[2] + 3);

    burst_phase = 1;
    if (p < 128)
      burst_phase = 0;

  }

  /* preload of the pixels used for the correlation */
  /* YUY2 format */
  cx_inc += cx_inc;
  for (i = 0; i < YSIZE; i++)
    {
      unsigned char *q;

      q = ((unsigned char **) lines)[i] + cx_start;
      for (j = 0; j < CX_COUNT; j += 4)
        {
          p[0] = q[0];
          q += cx_inc;
          p[1] = q[0];
          q += cx_inc;
          p[2] = q[0];
          q += cx_inc;
          p[3] = q[0];
          q += cx_inc;
          p += 4;
        }
    }

  /* Precompute the correlation between the lines, asm */
  correlation (&pts_buffer[0][0]);

  if (use_wss_line)
    /* C-Version */
    key_ptr = try_perm_useStatus ();
  else
    key_ptr = try_perm_asm ();

  key = (key_ptr - (unsigned short *) key_lines) / number_couples;
  gen_perm (perm, key);

#ifdef VBIDEBUG
  printf ("KEY: %04x\n", key);
#endif

  return key;
}


#ifndef DISABLE_ALL_FILTERS
inline void
half_blueline_filter(unsigned char *src, unsigned char **lines, unsigned short*perm, int xsize_src, int ysize)
{

      switch (bluefilter)
        {
#ifdef ENABLE_KIZKOOL25
        case BLUEFILTER_K25:
          CurrentX = xsize_src / 2;
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          FilterBlueLines25 ((long **) lines, perm, TRUE);
          break;
#endif

#ifdef ENABLE_KIZKOOL28
        case BLUEFILTER_K28:
          CurrentX = xsize_src / 2;
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          if (kizkool_param[BLUEFILTER_K28 - 1].smudge)
            {
              TypeImage = !(TypeImage);
              SecamFilter28 ((long **) lines, perm);
            }
          FilterBlueLines28 ((long **) lines, perm);
          break;
#endif

#ifdef ENABLE_KIZKOOL30
        case BLUEFILTER_K30:
          CurrentX = xsize_src / 2;
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          if (kizkool_param[BLUEFILTER_K30 - 1].smudge)
            {
              TypeImage = !(TypeImage);
              FindFrameType30 ((long **) lines, perm);
              SecamFilter30 ((long **) lines, perm);
            }
          FilterBlueLines30 ((long **) lines, perm);
          break;
#endif

#ifdef ENABLE_KIZKOOL31
        case BLUEFILTER_K31:
          CurrentX = xsize_src / 2;
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          if (kizkool_param[BLUEFILTER_K31 - 1].smudge)
            {
              TypeImage = !(TypeImage);
              FindFrameType31 ((long **) lines, perm);
            }

          FilterBlueLines31 ((long **) lines, perm);

          if (kizkool_param[BLUEFILTER_K31 - 1].smudge)
            SecamFilter31 ((long **) lines, perm);
          break;
#endif

#ifdef ENABLE_KIZKOOL32
        case BLUEFILTER_K32:
          CurrentX = xsize_src / 2;
          //printf("CurrentX = %d\n", CurrentX);
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          // The anti-smudge filter cannot be deactivated
          TypeImage = !(TypeImage);
          FindFrameType32 ((long **) lines, perm);
          SecamFiltering32 ((long **) lines, perm);
          break;
#endif

#ifdef ENABLE_SNABRAB
        case BLUEFILTER_K32SNABRAB:
          CurrentX = xsize_src / 2;
          //printf("CurrentX = %d\n", CurrentX);
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          // The anti-smudge filter cannot be deactivated
          TypeImage = !(TypeImage);
          FindFrameType32snabrab ((long **) lines, perm);
          SecamFiltering32snabrab ((long **) lines, perm);
          break;
#endif

#ifdef ENABLE_FASOUIL
        case BLUEFILTER_FAS:
          TailleDecodeTrame.cx = xsize_src/4;
          TailleDecodeTrame.cy = ysize/2-1;
          HauteurBandeNoire = ybar/2;
          FiltreImage (src, (long **) lines, perm, ODD,    TRUE /* save_src */ );
      break;
#endif
        }

}

inline void
full_blueline_filter(unsigned char *src, unsigned char **lines_e, unsigned char **lines_o, unsigned short*perm_e, unsigned short*perm_o, int xsize_src, int ysize)
{


      switch (bluefilter)
        {
#ifdef ENABLE_KIZKOOL25
        case BLUEFILTER_K25:
          CurrentX = xsize_src / 2;
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          FilterBlueLines25 ((long **) lines_e, perm_e, TRUE);
          FilterBlueLines25 ((long **) lines_o, perm_o, FALSE);
          break;
#endif

#ifdef ENABLE_KIZKOOL28       
        case BLUEFILTER_K28:
          CurrentX = xsize_src / 2;
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          if (kizkool_param[BLUEFILTER_K28 - 1].smudge)
            {
              SecamFilter28 ((long **) lines_e, perm_e);
            }
          FilterBlueLines28 ((long **) lines_e, perm_e);
          
          if (kizkool_param[BLUEFILTER_K28 - 1].smudge)
            {
              TypeImage = !(TypeImage);
              SecamFilter28 ((long **) lines_o, perm_o);
            }
          FilterBlueLines28 ((long **) lines_o, perm_o);
          break;
#endif

#ifdef ENABLE_KIZKOOL30
        case BLUEFILTER_K30:
          CurrentX = xsize_src / 2;
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          if (kizkool_param[BLUEFILTER_K30 - 1].smudge)
            {
              FindFrameType30 ((long **) lines_e, perm_e);
              SecamFilter30 ((long **) lines_e, perm_e);
            }
          FilterBlueLines30 ((long **) lines_e, perm_e);

          if (kizkool_param[BLUEFILTER_K30 - 1].smudge)
            {
              TypeImage = !(TypeImage);
              SecamFilter30 ((long **) lines_o, perm_o);
            }
          FilterBlueLines30 ((long **) lines_o, perm_o);
          break;
#endif

#ifdef ENABLE_KIZKOOL31
        case BLUEFILTER_K31:
          CurrentX = xsize_src / 2;
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          if (kizkool_param[BLUEFILTER_K31 - 1].smudge)
            FindFrameType31 ((long **) lines_e, perm_e);

          FilterBlueLines31 ((long **) lines_e, perm_e);

          if (kizkool_param[BLUEFILTER_K31 - 1].smudge)
            {
              SecamFilter31 ((long **) lines_e, perm_e);
              TypeImage = !(TypeImage);
            }

          FilterBlueLines31 ((long **) lines_o, perm_o);

          if (kizkool_param[BLUEFILTER_K31 - 1].smudge)
            SecamFilter31 ((long **) lines_o, perm_o);
          break;
#endif

#ifdef ENABLE_KIZKOOL32
        case BLUEFILTER_K32:
          CurrentX = xsize_src / 2;
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          // The anti-smudge filter cannot be deactivated
          //pLinesAddressEven = (long **)lines_e;
          FindFrameType32 ((long **) lines_e, perm_e);
          SecamFiltering32 ((long **) lines_e, perm_e);
          TypeImage = !(TypeImage);
          SecamFiltering32 ((long **) lines_o, perm_o);
          break;
#endif

#ifdef ENABLE_SNABRAB
        case BLUEFILTER_K32SNABRAB:
          CurrentX = xsize_src / 2;
          MovieScale = ybar/2-1;
          if (MovieScale < 0)
            MovieScale = 0;
          // The anti-smudge filter cannot be deactivated
          FindFrameType32snabrab ((long **) lines_e, perm_e);
          SecamFiltering32snabrab ((long **) lines_e, perm_e);
          TypeImage = !(TypeImage);
          SecamFiltering32snabrab ((long **) lines_o, perm_o);
          break;
#endif

#ifdef ENABLE_FASOUIL
        case BLUEFILTER_FAS:
          TailleDecodeTrame.cx = xsize_src/4;
          TailleDecodeTrame.cy = ysize/2-1;
          HauteurBandeNoire = ybar/2;
          FiltreImage (src, (long **) lines_e, perm_e, EVEN, FALSE /* save_src */ );
          FiltreImage (src, (long **) lines_o, perm_o, ODD,  TRUE  /* save_src */ );
          break;
#endif
        }

}
#endif // DISABLE_ALL_FILTERS
