#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <string.h>
//#include <pthread.h>

#include "videodev.h"
#include "bttv.h"

#include "colorspace.h"
#include "grab.h"

#include "crypt.h"
#include "nagra.h"
#include "ch5.h"
#include "vcrypt.h"
#include "const.h"
#include "oldcrypt.h"
#include "wintv_colors.h"
#include "vcryptkrank.h"
#include "xcrypt.h"
#include "attributes.h"
#include "cpu_accel.h"
#include "filtre.h"
#include "memcpy.h"

//extern pthread_mutex_t grab_mutex;
extern int have_xv;
extern int bttvfd;
extern int auto_decode;
extern int highquality;
extern int nagra_coded;
extern int use_nagraudio;
extern int bpp;
extern int ybar;
extern int ybar_auto;
extern struct GRABBER *grabbers[];
#ifndef DISABLE_ALL_KIZKOOL
 extern unsigned int CurrentFrame;
#endif
extern int hw_scaling;
static int bttvpriv=0; // private bbtv ioctl allowed ?

int decode = CLEAR;
extern int have_MMX;
int use_nagraudio = 0;
int nagraudio_mode = NAGRAUDIO_AUTO;

extern int x11_pixmap_format;
extern int x11_native_format;
extern struct video_mmap gb_even;
extern struct video_mmap gb_odd;
static struct video_mmap gb;
extern int even;
static int fqu=0;
extern int gb_grab;
extern int gb_sync;
extern char *map;
extern int pixmap_bytes;
extern struct video_mbuf gb_buffers;
extern int cur_norm;
extern int nagra_coded;

extern void set_sound_decoder (int mode, char *label);
extern void start_nagraudio (void);
extern void grab_wait (struct video_mmap *gb);
extern int grab_queue (struct video_mmap *gb);

void (*decode_fullframe)
  (unsigned char *dest,
   unsigned char *src,
   int xsize_dest, int xsize_src, int ysize, int dest_xsize) = NULL;
void (*decode_halfframe)
  (unsigned char *dest,
   unsigned char *src,
   int xsize_dest, int xsize_src, int ysize, int dest_xsize) = NULL;


static void
rgb16to24 (unsigned char *to, unsigned char *from, int pixels)
{
  int i;

  for (i = 0; i < pixels; i++)
    {
      to[0] = (*(from + 1)) & 0xf8;
      to[1] = (((*(from + 1)) & 0x07) << 5) + (((*from) & 0xe0) >> 3);
      to[2] = ((*from) & 0x1f) << 3;
      to += 3;
      from += 2;
    }
}


static void *
grab_scr2 (void *dest, int width, int height, int single, int dest_xsize)
{
  void *buf;
  int height_orig;
  int width_orig;
  int width_start;
  int offset;
  int y, count;
  void *dest1 = dest;
  int decodedch5;
  int decodealt;
  int secam;
  unsigned int fieldnr;
  static int burst_on = 0;
  struct video_mmap *gbp;

  /*
    if (debug)
      fprintf(stderr, "dest = 0x%0X\n", (unsigned int)dest);
  */
  //printf("grab_scr2: width = %d, height = %d, single = %d, dest_xsize = %d\n", width, height, single, dest_xsize);

  if ((char *) -1 == map)
    return NULL;

  if (!gb_even.format)
    return NULL;

  //pthread_mutex_lock(&grab_mutex);

  if (width > 768)
    width = 768;

  height_orig = height;
  width_orig = width;
  width_start = width;
  decodealt = decode;

  secam = (cur_norm == TVNORM_SECAM);

  if (nagra_coded >= 1)
    {
      decode = NAGRA;
    }

  if (decode == NAGRA)
    {
      height = 288 * 2;
      if(bttvpriv) {
      if (!secam)
        {
          //if (!burst_on)
            {
              ioctl (bttvfd, BTTV_BURST_ON, NULL);
              width += width*BURSTOFFSET/922;
              width &= ~1;
              burst_on = 1;
            }
        }
      else
        {
          if (burst_on)
            {
              ioctl (bttvfd, BTTV_BURST_OFF, NULL);
              burst_on = 0;
            }
        }
      }
    }
  else if ((decode > NAGRA) && (decode < NB_VIDEO_DECODER))
    {
      // xCRYPT family
      height = 288 * 2;
      width_orig = 720;
      width = 720;
      if(bttvpriv) {
      if (!secam)
        {
          if (!burst_on)
            {
              ioctl (bttvfd, BTTV_BURST_ON, NULL);
              width += width*BURSTOFFSET/922;
              width &= ~1;
              burst_on = 1;
            }
        }
      else
        {
          if (burst_on)
            {
              ioctl (bttvfd, BTTV_BURST_OFF, NULL);
              burst_on = 0;
            }
        }
      }
    }

  gb_even.width = width;
  gb_even.height = height;
  gb_odd.width = width;
  gb_odd.height = height;

  if (gb_buffers.frames>=3)
  {
   gb.frame  = 2;
   gb.format = VIDEO_PALETTE_YUV422;
   gb.width  = width;
   gb.height = height;

   if (gb_grab == gb_sync)
   {
    fqu++; fqu = fqu % 3;
    if (fqu==0) gbp = &gb_even;
    if (fqu==1) gbp = &gb_odd;
    if (fqu==2) gbp = &gb;
    if (-1 == grab_queue (gbp))
    {
     return NULL;
    }
   }

   fqu++; fqu=fqu % 3;
   if (fqu==0) gbp=&gb_even;
   if (fqu==1) gbp=&gb_odd;
   if (fqu==2) gbp=&gb;
   if (-1 == grab_queue (gbp))
   {
      //pthread_mutex_unlock(&grab_mutex);
       return NULL;
   }

    even = fqu - 2 ;
    if (even<0) even=even+3;
    if (even==0) gbp=&gb_even;
    if (even==1) gbp=&gb_odd;
    if (even==2) gbp=&gb;
    if (gb_grab > gb_sync)
    {
     grab_wait (gbp);
     buf = map + gb_buffers.offsets[even];
    }
    else
    {
     grab_wait(&gb_even);
     grab_wait(&gb_odd);
     grab_wait(&gb);
     fqu=even=gb_grab=gb_sync=0;
     return NULL;
    }
  }
  else
  {

  if (single)
    {
      if (gb_grab > gb_sync)
        grab_wait (even ? &gb_even : &gb_odd);
    }
  else
    {
      if (gb_grab == gb_sync)
        if (-1 == grab_queue (even ? &gb_even : &gb_odd))
          {
            //pthread_mutex_unlock(&grab_mutex);
            return NULL;
          }
    }

  if (-1 == grab_queue (even ? &gb_odd : &gb_even))
    {
      //pthread_mutex_unlock(&grab_mutex);
       return NULL;
    }

  if (gb_grab > gb_sync + 1)
    {
      grab_wait (even ? &gb_even : &gb_odd);
      buf = map + gb_buffers.offsets[even ? 0 : 1];
    }
  else
    {
      grab_wait (even ? &gb_odd : &gb_even);
      buf = map + gb_buffers.offsets[even ? 1 : 0];
    }
  even = !even;
 } /* else gp_buffers*/

#ifndef DISABLE_ALL_KIZKOOL
  if(bttvpriv) {
  if (-1 == ioctl (bttvfd, BTTV_FIELDNR, &fieldnr))
    {
      perror ("ioctl BTTV_FIELDNR");
    }
  else
    {
      CurrentFrame = fieldnr;
    }
  }
#endif


  //---------------------------------------------------------------------------
  //                     grab_scr2 : decode == CLEAR
  //--------------------------------------------------------------------------

  if (decode == CLEAR)
    {
      // Even if decode is CLEAR, unfortunately capture always occur in YUV422 format
      if (have_xv)
        {
          // This is the easiest part...
          if (dest_xsize != width)
            {
              for (y = 0; y < height; y++)
                fast_memcpy (dest + y * dest_xsize * pixmap_bytes,
                             buf + y * width * pixmap_bytes, width * pixmap_bytes);
            }
          else
            fast_memcpy (dest, buf, width * height * pixmap_bytes);
        }
      else // not have_xv
        {
          // Don't put anything else than RGB16 or YUV422 in buf2 !!!
          unsigned char buf2[width*height*2]; 

          if (dest_xsize != width)
            {
              if (x11_native_format == VIDEO_RGB16)
                {
                  for (y = 0; y < height; y++)
                    yuv_line_to_rgb_line (dest+ y * dest_xsize * 2,
                                          buf + y * width * 2, width);
                }
              else if (x11_native_format == VIDEO_RGB24)
                {
                  for (y = 0; y < height; y++)
                    yuv_line_to_rgb_line (buf2+ y * dest_xsize * 2,
                                          buf + y * width * 2, width);
                  rgb16to24(dest, buf2, dest_xsize*height);
                  // ?? swap_rgb24(dest, dest_xsize*height);
                }
              else if (x11_native_format == VIDEO_RGB32)
                {
                  for (y = 0; y < height; y++)
                    yuv_line_to_rgb_line (buf2+ y * dest_xsize * 2,
                                          buf + y * width * 2, width);
                  rgb16to24(buf, buf2, dest_xsize*height);
                  swap_rgb24(buf, dest_xsize*height);
                  rgb24_to_rgb32(dest, buf, dest_xsize, height);
                }
            }
          else
            {
              if (x11_native_format == VIDEO_RGB16)
                {
                  yuv_line_to_rgb_line(dest, buf, width*height);
                }
              else if (x11_native_format == VIDEO_RGB24)
                {
                  yuv_line_to_rgb_line(buf2, buf, width*height);
                  rgb16to24(dest, buf2, width*height);
                  // ?? swap_rgb24(dest, width*height);
                }
              else if (x11_native_format == VIDEO_RGB32)
                {
                  yuv_line_to_rgb_line(buf2, buf, width*height);
                  rgb16to24(buf, buf2, width*height);
                  swap_rgb24(buf, width*height);
                  rgb24_to_rgb32(dest, buf, width, height);
                }
            }
        }

    }
  //---------------------------------------------------------------------------
  //                      grab_scr2 : decode == NAGRA
  //--------------------------------------------------------------------------
  else if (decode == NAGRA)
    {

      if (nagraudio_mode == NAGRAUDIO_AUTO)
        {
          if (!nagra_coded)
            {
              if (use_nagraudio == 1)
                set_sound_decoder (CLEAR, "Auto");
            }
          else
            {
              if (use_nagraudio == 0)
                set_sound_decoder (NAGRA, "Auto");
            }
        }
      
      if (highquality)
        {
          //printf("width_orig = %d, width = %d\n", width_orig, width);
          decode_fullframe (
                            (unsigned char *) dest,
                            (unsigned char *) buf,
                            width_orig, width, height_orig, dest_xsize);
        }
      else
        {
          //printf("width_orig = %d, width = %d\n", width_orig, width);
          decode_halfframe (
                            (unsigned char *) dest,
                            (unsigned char *) buf,
                                width_orig, width, height_orig, dest_xsize);
        }


    }
  //---------------------------------------------------------------------------
  //                       grab_scr2 : decode == xCRYPT
  //--------------------------------------------------------------------------
  else if ((decode > 1) && (decode <= 7))
    {
      offset = ((width - width_orig) * 2);
      decodedch5 = 1;
      //if (decoded_vcrypt (buf) >= 0 || !automode)
      if (decoded_vcrypt (buf) >= 0 || (auto_decode != DECODER_AUTO))
        {
          switch (decode)
            {
            case SCRYPT:
              if (decodeFrame_ch5 ((unsigned char *) buf, width_orig, width)
                  == -1)
                {
                  decodeFrameVC (buf, width, 0, 10 + offset / 2);
                  decodedch5 = 0;
                }
              break;
            case KCRYPT:
              decodeFrameVCkrank (buf, width, 0, 10 + offset / 2);
              break;
            case HCRYPT:
              decodeFrameVC3 (buf, width, 0, 1);
              break;
            case XCRYPT:
              XdecodeFrameVC (buf, width, 0, 10 + offset / 2);
              break;
            default:
              decodeFrameVC (buf, width, 0, 10 + offset / 2);
            }
        }

      // verkleinern,
      buf += offset;

      // if ((decode != KEYCRYPT&&decode!= KEYCRYPTSAVE)||keyfoundok==1)
      // {
      count = YSIZE / 2 * 2;
      for (y = 0; y < YSIZE * 2; y++)
        {
          count += height_orig;
          if (count >= YSIZE * 2)
            {                    // Ausgabe
              yuv_line_to_rgb_line_ch5 (dest1, buf, width_orig, 10, y / 2,
                                        width_start);
              buf += width * pixmap_bytes;
              dest1 += dest_xsize * pixmap_bytes;
              count -= YSIZE * 2;
            }
          else
            {                    // Auslassen
              buf += width * pixmap_bytes;
            }
        }
      // }
    }


  //---------------------------------------------------------------------------
  //                       return descrambled buffer
  //--------------------------------------------------------------------------
  decode = decodealt;
  //pthread_mutex_unlock(&grab_mutex);
  return dest;
}



static void *
grab_one2 (int x11_format, int width, int height)
{
  struct video_mmap gb;
  char dest[width * (288 * 2) * 4]; // 4 for RGB32...
  int grab_format;

  if ((char *) -1 == map)
    return NULL;

  //pthread_mutex_lock(&grab_mutex);

  while (gb_grab > gb_sync)
  {
   if (gb_buffers.frames>=3)
  {
   gb.frame  = 2;
   gb.format = VIDEO_PALETTE_YUV422;
   gb.width  = width;
   gb.height = height;
   even=even+1; even=even%3;
   grab_wait(&gb_even);
   grab_wait(&gb_odd);
   grab_wait(&gb);
   fqu=even=gb_grab=gb_sync=0;
  }
    else
    grab_wait (even ? &gb_even : &gb_odd);
  }
  switch(x11_format)
    {
    case VIDEO_GRAY:
      if (debug)
        fprintf(stderr, "grab_one2: format = VIDEO_GRAY / VIDEO_PALETTE_GREY\n");
      grab_format = VIDEO_PALETTE_GREY;
      break;
    case VIDEO_RGB15:
      if (debug)
        fprintf(stderr, "grab_one2: format = VIDEO_RGB15 / VIDEO_PALETTE_RGB555\n");
      grab_format = VIDEO_PALETTE_RGB555;
      break;
    case VIDEO_RGB16:
      if (debug)
        fprintf(stderr, "grab_one2: format = VIDEO_RGB16 / VIDEO_PALETTE_RGB565\n");
      grab_format = VIDEO_PALETTE_RGB565;
      break;
    case -1:
    case VIDEO_RGB24:
      if (debug)
        fprintf(stderr, "grab_one2: format = VIDEO_RGB24 / VIDEO_PALETTE_RGB24\n");
      grab_format = VIDEO_PALETTE_RGB24;
      break;
    case VIDEO_RGB32:
      if (debug)
        fprintf(stderr, "grab_one2: format = VIDEO_RGB32 / VIDEO_PALETTE_RGB24\n");
      grab_format = VIDEO_PALETTE_RGB24;
      break;
    default:
      if (debug)
        fprintf(stderr, "grab_one2: format = UNKNOWN / VIDEO_PALETTE_RGB24\n");
      grab_format = VIDEO_PALETTE_RGB24;
      break;
    }

  if (decode == CLEAR)
    {
      gb.format = grab_format;
      gb.frame = 0;
      gb.width = width;
      gb.height = height;
    }
  else if (decode == NAGRA)
    {
      gb.format = VIDEO_PALETTE_YUV422;
      gb.frame = 0;
      gb.width = width;
      gb.height = 288 * 2;
    }
  else if ((decode > 1) && (decode <= 7))
    {
      gb.format = VIDEO_PALETTE_YUV422;
      gb.frame = 0;
      gb.width = width;
      gb.height = 288 * 2;
    }
  
  memset (map, 0, width * height * 3);
  if (-1 == grab_queue (&gb))
    {
      //pthread_mutex_unlock(&grab_mutex);
      return NULL;
    }
  grab_wait (&gb);

  if (decode == CLEAR)
  //---------------------------------------------------------------------------
  //                     grab_one2 : decode == CLEAR
  //---------------------------------------------------------------------------
    {
      // We are using one of the GRAY or RGB formats for the capture

      if ((x11_format == -1)||(x11_format == VIDEO_RGB24))
        {
          swap_rgb24 (map, width * height);
        }
      else if (x11_format == VIDEO_RGB32)
        {
          rgb24_to_rgb32 (dest, map, width, height);
          fast_memcpy(map, dest, width*height*4);
        }
    }
  else
  //---------------------------------------------------------------------------
  //            grab_one2 : decode != CLEAR (i.e. NAGRA, xCRYPT...)
  //---------------------------------------------------------------------------
    {
      int ybar_copy;
      int ybar_auto_copy;
      int count;
      unsigned char *p1;
      unsigned char *p2;
      int y;
      // We are using the YUV422 format for the capture

      ybar_copy = ybar;
      ybar_auto_copy = ybar_auto;
      ybar = 1;
      ybar_auto = 0;
      
      if (have_xv)
        {
          decode_halfframe ((unsigned char *) dest, (unsigned char *) map, width,
                            width, 2*288 , width);
        }
      else
        {
          decode_halfframe ((unsigned char *) dest, (unsigned char *) map, width,
                            width, height, width);
        }

      ybar = ybar_copy;
      ybar_auto = ybar_auto_copy;

      if (have_xv)
        {
          // result of decode_halfframe is in YUV422
          // and is 2*288 pixel height !!!
           
          // resize it
          if (height < 2*288)
            {
              p1 = (unsigned char *) dest;
              p2 = (unsigned char *) dest;
              count = 2*288;
              for (y = 0; y < 288 * 2; y++)
                {
                  count += height;
                    if (count >= 288 * 2)
                      {
                        // output line
                        fast_memcpy(p2, p1, width*2);
                        count -= 288 * 2;
                        p2 += width*2;
                      }
                  p1 += width*2;
                }
            }

          // convert it into rgb16
          yuv_line_to_rgb_line (map, dest, width*height);

          if ((x11_format == -1)||(x11_format == VIDEO_RGB24))
            {
                rgb16to24 ((unsigned char *) dest, (unsigned char *) map,
                           width * height);
                fast_memcpy (map, dest, width * height * 3); // RGB24 = 3 bytes per pixel
            }
          else if (x11_format == VIDEO_RGB32)
            {
                rgb16to24 ((unsigned char *) dest, (unsigned char *) map,
                           width * height);
                swap_rgb24 (dest, width * height);
                rgb24_to_rgb32 (map, dest, width, height);
            }
        }
      else // (not have_xv)
        {

          // result of decode_halfframe is either in RGB16 or RGB32
          // depending on current X server setting

          if ((x11_format == -1)||(x11_format == VIDEO_RGB24))
            {
              // We want an output in RGB24
              if (bpp == 16)
                {
                  rgb16to24 ((unsigned char *) map, (unsigned char *) dest,
                             width * height);
                }
              else
                {
                  rgb32_to_rgb24 (map, dest, width, height);
                  swap_rgb24 (map, width * height);
                }
            }
          else if (x11_format == VIDEO_RGB32)
            {
              fast_memcpy (map, dest, width * height * 4); // RGB32 = 4 bytes per pixel
            }
          else
            {
              // We want an output in RGB16, therefore a simple copy is sufficient
              // note that other RGB formats (15, 8, GRAY) are not taken into account
              fast_memcpy (map, dest, width * height * 2); // RGB16 = 2 bytes per pixel
            }
        }
    }

  //pthread_mutex_unlock(&grab_mutex);
  return map;
}

void
init_plugin (int grabber)
{
  int rc;
  if (debug)
    fprintf (stderr, "init_plugin: grabber = %d\n", grabber);
  fprintf (stderr, "\nLoading %s %s descrambling extensions.\n", PACKAGE, VERSION);
  fprintf (stderr, "It is intended for EDUCATIONAL PURPOSE only.\n\n");
  fprintf (stderr,
           "It wouldn't exist without:\n- Gerd Knorr for the original xawtv,\n");
  fprintf (stderr,
           "- Gaston, kamilh, M.Kuhn, Jens, Steffen and thebeast for the firsts xawdecodes,\n");
  fprintf (stderr,
           "Galtor's nagraudio inside with Maupatz MMX enhancement :)\n");
  fprintf (stderr, "24/32 bpp and Xvideo support by Maupatz\n");
  fprintf (stderr, "Special thanks to 1Konnu, Enek, KizKoool, Quenotte, Snabrab and Fasouil for their blue lines filters.\n");
  fprintf (stderr, "Another special thank to fl for helping me with Debian pecularities and SB16 like sound cards under Alsa.\n\n");


  if ( have_MMX == 0)
    {
      // From now on, MMX (and fast_memcpy, by the way) are  tested within xawdecode 
      // because of the new deinterlace functions
      // However we retest MMX just in case this wasn't done by xawdecode...
      if ( (have_MMX = mm_accel ()) == 0 )
        {
          fprintf (stderr, "No MMX detected: bad news: plugin deactivated!\n\n");
          return;
        }
    }
  
  if (decode > 0)
    {
      x11_pixmap_format = VIDEO_YUY2;
      gb_even.format = gb_odd.format = VIDEO_PALETTE_YUV422;
      pixmap_bytes = 2;
    }

  grabbers[grabber]->grab_scr = grab_scr2;
  grabbers[grabber]->grab_one = grab_one2;

  if (have_xv)
    {
      if (hw_scaling)
        {
          if (debug)
            printf("hw_scaling is ON\n");
          decode_fullframe = decode_fullframe_YUV_hw;
          decode_halfframe = decode_halfframe_YUV_hw;
        }
      else
        {
          if (debug)
            printf("hw_scaling is OFF\n");
          decode_fullframe = decode_fullframe_YUV_sw;
          decode_halfframe = decode_halfframe_YUV_sw;
        }
    }
  else
    {
      decode_fullframe = decode_fullframe_RGB;
      decode_halfframe = decode_halfframe_RGB;
    }

  init_decode ();

  if (use_nagraudio)
    set_sound_decoder (NAGRA, NULL);

  bttvpriv=0;
  if (-1 != (rc = ioctl(bttvfd, BTTV_VERSION, NULL))
      && rc >= 0x000700 && rc<0x000800)
    bttvpriv=1;
}
