// #include <wintv_std_includes.h>
#include "vcrypt.h"
#include "edge.h"
#include <sys/time.h>
#include <unistd.h>
#include "cpoints.h"
#include "ch5.h"
#include "memcpy.h"
#include <stdio.h>

extern int h_offset[288];
unsigned char blackline[1660 * 2];    // das braucht man nicht mal zu initialisieren, weil Nullen
int color_index_left[288], color_index_right[288];
int scryptphase = 0;
short *vc_keys = NULL;
int known_vc_keys = 0;
short *vc_key_ptr;
extern int movieburst;

//-----------------------------------------------
void
rotateFirstHalfLine (unsigned char *line, int shift, int xWidth, int skip)
{
  unsigned char tmp[2000];

  if (shift == 0)
    return;

  if (shift > 0)                // nach links
    {
      fast_memcpy (tmp, line, xWidth * 2);
      fast_memcpy (&line[2 * skip], &tmp[2 * (skip + shift)],
              2 * (xWidth - skip - shift));
      fast_memcpy (&line[2 * (xWidth - shift)], &tmp[2 * skip], 2 * shift);
    }
  else                            // nach rechts
    {
      shift = -shift;
      fast_memcpy (tmp, line, xWidth * 2);
      fast_memcpy (&line[2 * skip], &tmp[2 * (xWidth - shift)], 2 * shift);
      fast_memcpy (&line[2 * (skip + shift)], &tmp[2 * skip],
              2 * (xWidth - shift));
    }
}

//------------------------------------------------
int
findShift (unsigned char *baseline, unsigned char *line, int xWidth, int skip)
{
  unsigned int best_shift = 0;
  unsigned long int s, ls;
  unsigned char tbl[2000 * 2], tl[2000 * 2];
  int k, bs, step;

  fast_memcpy (tbl, &baseline[2 * skip], 2 * (xWidth - skip));
  fast_memcpy (tl, &line[2 * skip], 2 * (xWidth - skip));
  fast_memcpy (&tl[2 * (xWidth - skip)], &line[2 * skip], 2 * (xWidth - skip));

  step = 4;
  ls = 0;

  for (k = 0; k < (xWidth - skip); k += step)
    {
      s = line_diff3 (tbl, &tl[2 * k], xWidth - skip);
      if (s > ls)
        {
          best_shift = k;
          ls = s;
        }
    }

  bs = best_shift;
  if (bs < step)
    bs = step;
  if (bs > (xWidth - step - skip))
    bs = xWidth - step - skip;
  best_shift = 0;                // TOO SLOW
  ls = 0;
  for (k = bs - step; k < bs + step; k += 2)
    {
      s = line_diff3 (tbl, &tl[2 * k], xWidth - skip);
      if (s > ls)
        {
          best_shift = k;
          ls = s;
        }
    }

  return (best_shift);
}

//-------------------------------------------------
unsigned long int
line_diff3 (unsigned char *bline, unsigned char *line, int width)
{
// berechnet die summe der y-differenzen fuer bline/line

  int s = 0, li, bi;
  int k;

  for (k = 0; k < width; k += 2)
    {
      bi = (int) bline[2 * k];
      li = (int) line[2 * k];
      s += bi * li;
    }

  return (s);
}

//-------------------------------------------------
void
make_yuyv (unsigned char *p1, int *y1, int *u, int *y2, int *v,
           int cp, int line_nr, int wo)
{

// berechnet werden die yuyv werte bei p1 , entsprechend scryptphase (global),
// offset, line_nr und seite der zeile ( 0-left, 1-right)

  int phase, index;
  int u1, u2, v1, v2;

  u1 = (int) p1[1] - 128;
  v1 = (int) p1[3] - 128;

  phase = (scryptphase + line_nr) % 2;
  index = cp | (phase << 10) | (wo << 11);

//printf("index: %d\n",index);

  u2 = (u1 * cos_table[index] - v1 * sin_table[index]) >> 8;
  v2 = (u1 * sin_table[index] + v1 * cos_table[index]) >> 8;

  *y1 = (int) p1[0];
  *u = (int) (u2 + 128);
  *y2 = (int) p1[2];
  *v = (int) (v2 + 128);
}

//-------------------------------------------------
/*
void make_yuyv(unsigned char *p1,int *y1,int *u,int *y2,int *v,
               int cp,int line_nr,int wo)
{

// berechnet werden die yuyv werte bei p1 , entsprechend scryptphase (global),
// offset, line_nr und seite der zeile ( 0-left, 1-right)

double u1,u2,v1,v2,wl,wr,nwl,nwr;

u1=(double)p1[1]-128;
v1=(double)p1[3]-128;

if (line_nr%2==scryptphase)
  {
   //nwl=normal_winkel(m1l*cp+k1l);
   //nwr=normal_winkel(m1r*cp+k1r);
   nwl=m1l*cp+k1l;
   nwr=m1r*cp+k1r;
   wl=PI*nwl/180.0;
   wr=PI*nwr/180.0;
  }
   else
     {
     nwl=normal_winkel(m2l*cp+k2l);
     nwr=normal_winkel(m2r*cp+k2r);
     nwl=m2l*cp+k2l;
     nwr=m2r*cp+k2r;     
     wl=PI*nwl/180.0;
     wr=PI*nwr/180.0;          
     }


if (wo==0)
 { 
   u2=u1*cos(wl)-v1*sin(wl); 
   v2=u1*sin(wl)+v1*cos(wl); 
   } 
else { 
       u2=u1*cos(wr)-v1*sin(wr); 
       v2=u1*sin(wr)+v1*cos(wr); 
       } 

*y1=(int)p1[0];
*u=(int)(u2+128);
*y2=(int)p1[2];
*v=(int)(v2+128);

}
*/
//-------------------------------------------------
unsigned long int
line_diff2 (unsigned char *bline, unsigned char *line, int width,
            unsigned long int limit)
{
// berechnet die summe der y-differenzen fuer bline/line,
// solange limit nicht ueberschritten wird

  unsigned long int s = 0, li, bi;
  int k;

  for (k = 0; k < width; k += 4)
    {
      bi = (unsigned long int) bline[2 * k];
      li = (unsigned long int) line[2 * k];
      s += (bi - li) * (bi - li);
      if (s > limit)
        return (0xffffffff);
    }

  return (s);
}

//-------------------------------------------------
void
autoDetectEdges (unsigned char *baseline, unsigned char *line,
                 int xWidth, int skip,
                 int blnr, int lnr, int bloff, int loff, int *bl_shift,
                 int *l_shift)
{
  int offsets1[4], offsets2[4];
  unsigned long int ldiffs1[4], ldiffs2[4], bs = 0xffffffff, ls;
  int i, j, best_index = 0, shift1, shift2;

  autoDetectEdges2 (baseline, line, xWidth, skip, blnr, lnr, bloff, loff,
                    offsets1, ldiffs1);
//for(i=0;i<4;i++) printf("bles: %d  les: %d  diff: %ld\n",(offsets1[i] >> 8)-40,(offsets1[i] & 255) -40,ldiffs1[i]);

  autoDetectEdges2 (line, line + 4 * xWidth, xWidth, skip, lnr, lnr + 1, loff,
                    h_offset[lnr + 1], offsets2, ldiffs2);
//for(i=0;i<4;i++) printf("bles: %d  les: %d  diff: %ld\n",(offsets2[i] >> 8)-40,(offsets2[i] & 255) -40,ldiffs2[i]);

//autoDetectEdges2(line+4*xWidth,line+8*xWidth,xWidth,skip,lnr+1,lnr+2,
//                 h_offset[lnr+1],h_offset[lnr+2],offsets3,ldiffs3);
//for(i=0;i<4;i++) printf("bles: %d  les: %d  diff: %ld\n",(offsets3[i] >> 8)-40,(offsets3[i] & 255) -40,ldiffs3[i]);


  for (i = 0; i < 4; i++)
    {
      shift1 = (offsets1[i] & 255) - 40;
      for (j = 0; j < 4; j++)
        {
          shift2 = (offsets2[j] >> 8) - 40;
          if (shift2 == shift1)
            {
              ls = ldiffs1[i] + ldiffs2[j];
              if (ls < bs)
                {
                  best_index = i;
                  bs = ls;
                }
            }
        }
    }

  *bl_shift = (offsets1[best_index] >> 8) - 40;
  *l_shift = (offsets1[best_index] & 255) - 40;

}

//-------------------------------------------------
void
differenzen_ordnen (int *offsets, unsigned long int *ldiffs, int anzahl)
{
  int a, i, j, k;
  unsigned long int min, d;

  for (i = 0; i < anzahl; i++)
    {
      a = i;
      min = ldiffs[i];
      for (j = i; j < anzahl; j++)
        if (ldiffs[j] < min)
          {
            min = ldiffs[j];
            a = j;
          }
      if (a != i)
        {
          k = offsets[i];
          d = ldiffs[i];
          offsets[i] = offsets[a];
          ldiffs[i] = ldiffs[a];
          offsets[a] = k;
          ldiffs[a] = d;
        }
    }

}

//-------------------------------------------------
void
autoDetectEdges2 (unsigned char *baseline, unsigned char *line,
                  int xWidth, int skip,
                  int blnr, int lnr, int bloff, int loff, int *offsets,
                  unsigned long int *ldiffs)
{

// vorausgesetzt wird, dass durch die vorkorrelation beide zeilen fast richtig sind.
// die routine sucht fuer BEIDE zeilen extra_offsets (+-6) damit die geringste farbabweichung
// entsteht und findet somit hoffentlich die richtigen randpositionen

//#define autoDetectEdges2Debug 1

  unsigned char tbl[2000 * 2], tl[2000 * 2];
  int width;
  unsigned char *p1, *p2;
  int bl_gerade = 0, l_gerade = 0, i, j, bl_extra_offset, l_extra_offset;
  unsigned long int ls, li, lix[51 * 5];
  int best_bl_shift = 0, best_l_shift = 0, counter = 0;
  int abtast_amplitude = 20;    // max 25
  int off_komb[51 * 5];

#ifdef autoDetectEdges2Debug
  printf ("ade  blnr: %d  off[%d]: %d   lnr: %d  off[%d]: %d\n",
          blnr, blnr, h_offset[blnr], lnr, lnr, h_offset[lnr]);
#endif

  fast_memcpy (tbl, &baseline[2 * skip], 2 * (xWidth - skip));
  fast_memcpy (&tbl[2 * (xWidth - skip)], &baseline[2 * skip],
          2 * (xWidth - skip));
  fast_memcpy (tl, &line[2 * skip], 2 * (xWidth - skip));
  fast_memcpy (&tl[2 * (xWidth - skip)], &line[2 * skip], 2 * (xWidth - skip));

  ls = 0xffffffff;

  if (bloff % 2 == 0)
    bl_gerade = 1;
  if (loff % 2 == 0)
    l_gerade = 1;

  width = xWidth - skip;

  for (i = -abtast_amplitude; i <= abtast_amplitude; i += 2)
    {
      bl_extra_offset = i + bl_gerade;
      if (bl_extra_offset < 0)
        p1 = &tbl[2 * width + 2 * bl_extra_offset];
      else
        p1 = &tbl[2 * bl_extra_offset];
      for (j = (i - 4); j <= (i + 4); j += 2)
        {
          l_extra_offset = j + l_gerade;
          if (l_extra_offset < 0)
            p2 = &tl[2 * width + 2 * l_extra_offset];
          else
            p2 = &tl[2 * l_extra_offset];
          li = line_diff4 (p1, p2, width,
                           blnr, h_offset[blnr] + bl_extra_offset,
                           lnr, h_offset[lnr] + l_extra_offset,
                           width - (h_offset[blnr] + bl_extra_offset),
                           width - (h_offset[lnr] + l_extra_offset));
#ifdef autoDetectEdges2Debug
//     printf("es1: %d  es2: %d  diff: %ld\n",bl_extra_offset,l_extra_offset,li);              
#endif
          lix[counter] = li;
          off_komb[counter] =
            ((bl_extra_offset + 40) << 8) | (l_extra_offset + 40);
          counter++;

          if (li < ls)
            {
              ls = li;
              best_bl_shift = bl_extra_offset;
              best_l_shift = l_extra_offset;
            }
        }
    }

  differenzen_ordnen (off_komb, lix, (abtast_amplitude + 1) * 5);

  for (i = 0; i < 4; i++)
    {
      offsets[i] = off_komb[i];
      ldiffs[i] = lix[i];
    }
#ifdef autoDetectEdges2Debug
  // printf("bbls: %d  bls: %d  \n",best_bl_shift,best_l_shift);              

  for (i = 0; i < 4; i++)
    {
      printf ("bles: %d  les: %d  diff: %ld\n", (off_komb[i] >> 8) - 40,
              (off_komb[i] & 255) - 40, lix[i]);
    }
#endif

}

//-------------------------------------------------
int
findExtraShift2 (unsigned char *baseline, unsigned char *line,
                 int xWidth, int skip, int blnr, int lnr)
{

// vorausgesetzt wird, dass baseline absolut am richtigen ort ist und auch line
// schon "vorkorreliert" wurde
// line wird im bereich +-6 (step=2) an baseline angepasst, so dass die farbe von 
// baseline gehalten wird. der abgleich findet ueber die ganze zeile statt

  int best_shift = 0;
  unsigned long int li, ls;
  unsigned char tbl[2000 * 2], tl[2000 * 2];
  int width;
  unsigned char *p1, *p2;
  int gerade = 0, i, extra_offset;

  if (h_offset[lnr] % 2 == 0)
    gerade = 1;

  fast_memcpy (tbl, &baseline[2 * skip], 2 * (xWidth - skip));
  fast_memcpy (tl, &line[2 * skip], 2 * (xWidth - skip));
  fast_memcpy (&tl[2 * (xWidth - skip)], &line[2 * skip], 2 * (xWidth - skip));

  ls = 0xffffffff;

  p1 = tbl;
  width = xWidth - skip;

  for (i = -6; i <= 6; i += 2)
    {
      extra_offset = i + gerade;
      if (extra_offset < 0)
        p2 = &tl[2 * width + 2 * extra_offset];
      else
        p2 = &tl[2 * extra_offset];
      li = line_diff4 (p1, p2, width,
                       blnr, h_offset[blnr],
                       lnr, h_offset[lnr] + extra_offset,
                       width - h_offset[blnr],
                       width - (h_offset[lnr] + extra_offset));
      if (li < ls)
        {
          best_shift = extra_offset;
          ls = li;
        }
    }

  return (best_shift);
}

//-------------------------------------------------
unsigned long int
line_diff4 (unsigned char *bline, unsigned char *line,
            int width,
            int blnr, int bloff, int lnr, int loff,
            int bl_left_length, int l_left_length)
{

// berechnet die summe der y, u und v-differenzen von bline und line.
// wird verwendet zum abgleich von 2 zeilen auf die farb-werte
// damit die farbwerte (in der regel viel kleiner als luminamzen) mit einer
// ordentlichen wichtung eingehen werden sie vorher "hochskaliert"

  unsigned long int s = 0;
  int k;
  unsigned char *p1, *p2;
  int bly1, bly2, blu, blv, ly1, ly2, lu, lv;
  unsigned char bline2[2000], line2[2000];
  int cmax, c, i;
  double f;

  fast_memcpy (bline2, bline, width * 2);
  fast_memcpy (line2, line, width * 2);

  cmax = 0;
  p1 = bline;
  for (i = 0; i < width / 2; i++)
    {
      c = abs ((int) p1[1] - 128);
      if (c > cmax)
        cmax = c;
      c = abs ((int) p1[3] - 128);
      if (c > cmax)
        cmax = c;
      p1 += 4;
    }

  p1 = line;
  for (i = 0; i < width / 2; i++)
    {
      c = abs ((int) p1[1] - 128);
      if (c > cmax)
        cmax = c;
      c = abs ((int) p1[3] - 128);
      if (c > cmax)
        cmax = c;
      p1 += 4;
    }

  f = 127.0 / cmax;
  f = f / 2.0;

  p1 = bline2;
  for (i = 0; i < width / 2; i++)
    {
      c = (int) ((p1[1] - 128) * f) + 128;
      p1[1] = (unsigned char) c;
      c = (int) ((p1[3] - 128) * f) + 128;
      p1[3] = (unsigned char) c;
      p1 += 4;
    }

  p1 = line2;
  for (i = 0; i < width / 2; i++)
    {
      c = (p1[1] - 128) * f + 128;
      p1[1] = (unsigned char) c;
      c = (p1[3] - 128) * f + 128;
      p1[3] = (unsigned char) c;
      p1 += 4;
    }

  p1 = bline2;
  p2 = line2;
  k = 0;

  while (k < width / 2)
    {
      if (2 * k < bl_left_length)
        make_yuyv (p1, &bly1, &blu, &bly2, &blv, bloff, blnr, 0);
      else
        make_yuyv (p1, &bly1, &blu, &bly2, &blv, bloff, blnr, 1);
      if (2 * k < l_left_length)
        make_yuyv (p2, &ly1, &lu, &ly2, &lv, loff, lnr, 0);
      else
        make_yuyv (p2, &ly1, &lu, &ly2, &lv, loff, lnr, 1);
      s = s +
        (bly1 - ly1) * (bly1 - ly1) +
        (bly2 - ly2) * (bly2 - ly2) +
        (blu - lu) * (blu - lu) + (blv - lv) * (blv - lv);
      p1 += 4;
      p2 += 4;
      k += 1;
    }

  return (s);
}

//-------------------------------------------------
void
vc_pre_correlation (unsigned char *buffer, int xBufferWidth_,
                    int yBorderHeight)
{
  int skip = 68;
  int xBufferWidth = 778;
  int i, j;

  for (i = 0; i < 288; i++)
    h_offset[i] = 0;

  for (i = yBorderHeight + 1; i < (287 - yBorderHeight); i++)
    {
      j =
        findShift (&buffer[2 * i * 2 * xBufferWidth],
                   &buffer[2 * (i + 1) * 2 * xBufferWidth], xBufferWidth,
                   skip);
      if (j % 2 == 1)
        j++;
      rotateFirstHalfLine (&buffer[2 * (i + 1) * 2 * xBufferWidth], j,
                           xBufferWidth, skip);
      h_offset[i + 1] = j;
    }

  edgeCorrection (buffer, xBufferWidth, skip, yBorderHeight);

}

//-----------------------------------------------
void
vc_bild_ausrichtung (unsigned char *buffer, int xWidth, int skip, int line,
                     int shift)
{
  int ub, i, j;
  int a = shift;

  if (a != 0)
    {
      rotateFirstHalfLine (&buffer[2 * (line) * 2 * xWidth], a, xWidth, skip);
      h_offset[line] = (h_offset[line] + a) % 710;
    }

  ub = a;
  for (i = line + 1; i < 286; i++)
    {
      if (ub != 0)
        {
          rotateFirstHalfLine (&buffer[2 * (i) * 2 * xWidth], ub, xWidth,
                               skip);
          h_offset[i] = (h_offset[i] + ub) % 710;
        }
      j =
        findExtraShift2 (&buffer[2 * (i - 1) * 2 * xWidth],
                         &buffer[2 * (i) * 2 * xWidth], xWidth, skip, i - 1,
                         i);
      rotateFirstHalfLine (&buffer[2 * (i) * 2 * xWidth], j, xWidth, skip);
      h_offset[i] = (h_offset[i] + j) % 710;
      ub = (ub + j) % 710;
    }

  ub = a;

  for (i = line - 1; i > 1; i--)
    {
      if (ub != 0)
        {
          rotateFirstHalfLine (&buffer[2 * (i) * 2 * xWidth], ub, xWidth,
                               skip);
          h_offset[i] = (h_offset[i] + ub) % 710;
        }
      j =
        findExtraShift2 (&buffer[2 * (i + 1) * 2 * xWidth],
                         &buffer[2 * (i) * 2 * xWidth], xWidth, skip, i + 1,
                         i);
      rotateFirstHalfLine (&buffer[2 * (i) * 2 * xWidth], j, xWidth, skip);
      h_offset[i] = (h_offset[i] + j) % 710;
      ub = (ub + j) % 710;
    }
}

//-----------------------------------------------
void
decodeFrameVC3 (unsigned char *buffer, int xBufferWidth_, int yBorderHeight,
                int color)
{
  int skip = 0;
  int i;
  int xBufferWidth;
  int a, b;
  int detect_line;

  xBufferWidth = 778;
  skip = 68;

  scryptphase = get_burst (buffer, xBufferWidth);
  vc_pre_correlation (buffer, xBufferWidth, yBorderHeight);

  if (color)
    {
      detect_line = 140;
      autoDetectEdges (&buffer[2 * xBufferWidth * 2 * detect_line],
                       &buffer[2 * xBufferWidth * 2 * (detect_line + 1)],
                       xBufferWidth, skip,
                       detect_line, detect_line + 1,
                       h_offset[detect_line], h_offset[detect_line + 1], &a,
                       &b);
      vc_bild_ausrichtung (buffer, xBufferWidth, skip, detect_line, a);
    }

  for (i = yBorderHeight; i < (288 - yBorderHeight); i++)
    fast_memcpy (&buffer[(2 * i + 1) * 2 * xBufferWidth],
            &buffer[(2 * i) * 2 * xBufferWidth], 2 * xBufferWidth);


  make_color_index ();
}

//-----------------------------------------------
int
decoded_vcrypt (unsigned char *buffer)
{
  int skip, i;
  int width;

  skip = 10;
  width = 778;
  skip = 68;
  i = find_vc_key (buffer, width, skip);

  scryptphase = get_burst (buffer, width);

  if (i == -2)
    {
      for (i = 1; i < 288; i++)
        {
          h_offset[i] = 0;
          make_color_index ();
        }
      return (-1);
    }
  return (1);
}

//----------------------------------------------
int
find_vc_key (unsigned char *buffer, int xWidth, int skip)
{
  int referenzes[10] = { 50, 70, 90, 110, 130, 150, 170, 190, 210, 230 };
  int i, j, l, matches = 0;
  int shifts[287];

  for (i = 0; i < 10; i++)
    {
      l = referenzes[i];
      shifts[l] =
        findShift (&buffer[2 * (l - 1) * 2 * xWidth],
                   &buffer[2 * l * 2 * xWidth], xWidth, skip);
    }

  vc_key_ptr = vc_keys;
  matches = 0;
  for (j = 0; j < 10; j++)
    {
      l = referenzes[j];
      if (abs (0 - shifts[l]) < 20)
        matches++;
    }
  if (matches > 5)
    {
      return (-2);
    }

  return (-1);
}

//----------------------------------------------
